Public Class AusstehendBefundControl
    Inherits TreeView
    Private WithEvents m_Befunde As BefundTextEintragsListe = Nothing
    Private WithEvents m_Stichworte As BefundStichwortListe
    Private m_Pat As Patient

    Private m_TempText As String = ""

    Public Event NavigateToBefund(ByVal Befund As PatientBefund)

    Public Sub SetSource(ByVal Pat As Patient, ByVal Stichworte As BefundStichwortListe)
        If m_Pat IsNot Pat Then
            m_Pat = Pat
            If m_Pat Is Nothing Then
                m_Befunde = Nothing
                m_Stichworte = Nothing
            Else
                m_Befunde = m_Pat.Befunde
                m_Stichworte = Stichworte
            End If
            ReadSource()
        End If
    End Sub
   
    Private Sub ReadSource()

        Dim PflichtBefunde As New List(Of BefundStichwort)
        Dim SwLowerWords As New List(Of String)

        Dim LeerBefunde As New List(Of BefundTextEintrag)

        Dim TmpTreeNodes As New List(Of TreeNode)

        If m_Stichworte IsNot Nothing Then
            Dim Found As Boolean = False
            For Each SW As BefundStichwort In m_Stichworte
                If SW.IstPflichtUntersuchung Then
                    Found = False
                    For Each Bef As BefundTextEintrag In m_Befunde
                        If Bef.Kategorie.ToLower = SW.KurzWort.ToLower Then
                            If Bef.Text.Trim <> "" Then
                                Found = True
                                Exit For
                            End If
                        End If
                    Next
                    If Not Found Then
                        PflichtBefunde.Add(SW)
                        SwLowerWords.Add(SW.KurzWort.ToLower)
                    End If
                End If
            Next

            For Each Bef As BefundTextEintrag In m_Befunde
                If Not Bef.IsEmpty Then
                    If Bef.Kategorie <> "" AndAlso Bef.Text.Trim = "" Then
                        If Not SwLowerWords.Contains(Bef.Kategorie.ToLower) Then
                            LeerBefunde.Add(Bef)
                        End If
                    End If
                End If
            Next

            For Each SW As BefundStichwort In PflichtBefunde
                Dim Newnode As New TreeNode(SW.KurzWort)
                Newnode.ForeColor = ColorLib.WarningColor1
                TmpTreeNodes.Add(Newnode)
            Next
            For Each Bef As BefundTextEintrag In LeerBefunde
                TmpTreeNodes.Add(New PatientBefundTreeNode(New PatientBefund(m_Pat, Bef), True))
            Next

        End If


        Dim TempText As String = ""
        For Each Nd As TreeNode In TmpTreeNodes
            TempText &= Nd.Text
        Next
        If m_TempText <> TempText Then
            m_TempText = TempText
            Me.Nodes.Clear()
            Me.Nodes.AddRange(TmpTreeNodes.ToArray)
            Me.ExpandAll()
        End If

    End Sub

    Private Sub m_source_Changed(ByVal PropertyName As String) Handles m_Befunde.Changed
        ReadSource()
    End Sub

    Private Sub m_Stichworte_Changed() Handles m_Stichworte.Changed
        ReadSource()
    End Sub
    Public Sub New()
        Me.ShowLines = False
        Me.ShowPlusMinus = False
        Me.ShowRootLines = False
        Me.HideSelection = True
    End Sub

    Private Sub AusstehendBefundControl_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles Me.AfterSelect
        Try
            Dim Node As PatientBefundTreeNode = Me.SelectedNode
            RaiseEvent NavigateToBefund(Node.PatBef)
        Catch ex As Exception

        End Try
    End Sub
End Class
