Public Class ValidatedDateTextBox
    Inherits TextBox
    Private m_Highlighted As Boolean = False
    Private m_HasError As Boolean = False
    WriteOnly Property Highlighted() As Boolean
        Set(ByVal value As Boolean)
            m_Highlighted = value
            SetColors()
        End Set
    End Property
    Private WriteOnly Property HasError() As Boolean
        Set(ByVal value As Boolean)
            m_HasError = value
            SetColors()
        End Set
    End Property
    Private Sub ValidatedDateTextBox_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles Me.Validating
        If Me.Text.Trim = "" Then
            HasError = False
        Else
            Dim Dat As New ParsedDate(Me.Text.Trim)
            HasError = Dat.HasError
            If Not Dat.HasError Then
                Me.Text = Dat.Datum.ToShortDateString
            End If
        End If
    End Sub
    Private Sub SetColors()
        If m_HasError Then
            Me.BackColor = Color.Red
            Me.ForeColor = Color.White
        Else
            If m_Highlighted Then
                Me.BackColor = SystemColors.Window
                Me.ForeColor = Color.Red
            Else
                Me.BackColor = SystemColors.Window
                Me.ForeColor = Color.Black
            End If
        End If
    End Sub

End Class
