Public Class EKGEditorItem
    Implements IEditorControlItem

    Public Event ShouldBeDeleted(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.ShouldBeDeleted
    Public Event WasSelected(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.WasSelected

    Private WithEvents m_Source As EKGBefund
    Private m_Initializing As Boolean = False

    Private m_Expanded As Boolean = True
    Private Sub SetExpanded(ByVal NewValue As Boolean)
        If m_Expanded <> NewValue Then
            m_Expanded = NewValue
            Dim ExtraHeight As Integer = 20
            If m_Expanded Then
                Me.ButtonExpand.Image = My.Resources.AufklappUp
                Me.Height += ExtraHeight
            Else
                Me.ButtonExpand.Image = My.Resources.AufklappDown
                Me.Height -= ExtraHeight
            End If
        End If

    End Sub
    Private Sub ButtonExpand_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonExpand.Click
        SetExpanded(Not m_Expanded)
    End Sub

    Public ReadOnly Property Source() As ChangeListItem Implements IEditorControlItem.Source
        Get
            Return m_Source
        End Get
    End Property

    Private Sub EditorItem_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        RaiseEvent WasSelected(Me)
    End Sub

    Private Sub Button1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Button1.KeyUp
        If e.KeyCode = Keys.Delete Then
            RaiseEvent ShouldBeDeleted(Me)
        End If
    End Sub

  


    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub
    Public Sub New(ByVal Source As EKGBefund, ByVal Expanded As Boolean)
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        For I As Integer = 0 To 6
            Me.ComboBoxLagetyp.Items.Add(CType(I, EKGLageTypen))
        Next
        Read_Source()
        SetExpanded(Expanded)
    End Sub
    Private Sub Read_Source()
        m_Initializing = True
        Me.TextBoxDetails.Text = m_Source.Text
        Me.CheckBoxWichtig.Checked = m_Source.Wichtig
        Dim MinDatum As New Date(1860, 1, 1)
        If m_Source.Datum < MinDatum Then
            Me.TextBoxDatum.Text = ""
        Else
            Me.TextBoxDatum.Text = m_Source.Datum.ToShortDateString
        End If
        If m_Source.Wichtig Then
            Me.TextBoxDetails.ForeColor = Color.Red
            Me.TextBoxDatum.Highlighted = True
        Else
            Me.TextBoxDetails.ForeColor = Color.Black
            Me.TextBoxDatum.Highlighted = False
        End If

        Me.CheckBoxEditiert.Checked = m_Source.SelfEdited
        Me.ComboBoxLagetyp.SelectedItem = m_Source.LageTyp
        Me.CheckBoxAA.Checked = m_Source.AbsoluteArrhythmie
        Me.TextBoxFrequenz.Text = m_Source.Frequenz.ToString

        If m_Source.SelfEdited Then
            Me.ComboBoxLagetyp.Enabled = False
            Me.CheckBoxAA.Enabled = False
            Me.TextBoxFrequenz.Enabled = False
        Else
            Me.ComboBoxLagetyp.Enabled = True
            Me.CheckBoxAA.Enabled = True
            Me.TextBoxFrequenz.Enabled = True
        End If
        m_Initializing = False
    End Sub

    Private Sub m_Source_SelfEdited_Changed() Handles m_Source.SelfEdited_Changed

        m_Initializing = True
        If m_Source.SelfEdited Then
            Me.CheckBoxEditiert.Checked = True
            Me.ComboBoxLagetyp.Enabled = False
            Me.CheckBoxAA.Enabled = False
            Me.TextBoxFrequenz.Enabled = False
        Else
            Me.CheckBoxEditiert.Checked = False
            Me.ComboBoxLagetyp.Enabled = True
            Me.CheckBoxAA.Enabled = True
            Me.TextBoxFrequenz.Enabled = True
        End If
        m_Initializing = False
    End Sub

    Private Sub m_Source_TextChanged() Handles m_Source.TextChanged
        m_Initializing = True
        TextBoxDetails.Text = m_Source.Text
        m_Initializing = False
    End Sub

    Private Sub TextBoxDetails_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxDetails.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Text = TextBoxDetails.Text
        m_Source.SelfEdited = True
    End Sub

    Private Sub CheckBoxEditiert_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxEditiert.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Source.SelfEdited = CheckBoxEditiert.Checked
    End Sub

    Private Sub ComboBoxLagetyp_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxLagetyp.SelectedIndexChanged
        If m_Initializing Then Exit Sub
        m_Source.LageTyp = ComboBoxLagetyp.SelectedItem
    End Sub
    Private Sub CheckBoxWichtig_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxWichtig.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Source.Wichtig = CheckBoxWichtig.Checked
        If m_Source.Wichtig Then
            Me.TextBoxDetails.ForeColor = Color.Red
            Me.TextBoxDatum.Highlighted = True
        Else
            Me.TextBoxDetails.ForeColor = Color.Black
            Me.TextBoxDatum.Highlighted = False
        End If
    End Sub
    Private Sub TextBoxFrequenz_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxFrequenz.TextChanged
        If m_Initializing Then Exit Sub
        Try
            m_Source.Frequenz = CInt(TextBoxFrequenz.Text)
            TextBoxFrequenz.BackColor = SystemColors.Window
            TextBoxFrequenz.ForeColor = Color.Black
        Catch ex As Exception
            m_Source.Frequenz = 0
            TextBoxFrequenz.BackColor = Color.Red
            TextBoxFrequenz.ForeColor = Color.White
        End Try
    End Sub

    Private Sub CheckBoxAA_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAA.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Source.AbsoluteArrhythmie = CheckBoxAA.Checked
    End Sub

    Private Sub TextBoxDetails_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxDetails.Validating
        If m_Initializing Then Exit Sub
        m_Source.ValidateText()
    End Sub
    Private Sub TextBoxDatum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxDatum.TextChanged
        Dim Dat As New ParsedDate(TextBoxDatum.Text)
        m_Source.Datum = Dat.Datum
    End Sub
    Private Sub TextBoxDatum_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxDatum.Validating
        If m_Initializing Then Exit Sub
        m_Source.ValidateDatum()
    End Sub

    
End Class
