Imports System.Xml
Public Class LaborBefund
    Inherits BefundTextEintrag

    Private m_SelfEdited As Boolean = False

    Public Event SelfEdited_Changed()
    Public Event TextChanged()

    Private m_BSG As String = ""
    Private m_CRP As String = ""
    Private m_BiliG As String = ""
    Private m_ALAT As String = ""
    Private m_ASAT As String = ""
    Private m_Amyl As String = ""
    Private m_Lip As String = ""

    Public Sub New(ByVal Parent As BefundTextEintragsListe)
        MyBase.New(Parent)
        m_Kategorie = "Labor"
        CreateNewText()
    End Sub
    Public Sub New(ByVal Parent As BefundTextEintragsListe, ByVal Nd As XmlNode)
        MyBase.New(Parent, Nd)
        m_BSG = Nd.Attributes("BSG").Value
        m_CRP = Nd.Attributes("CRP").Value
        m_BiliG = Nd.Attributes("BiliG").Value
        m_ALAT = Nd.Attributes("ALAT").Value
        m_ASAT = Nd.Attributes("ASAT").Value
        m_Amyl = Nd.Attributes("Amyl").Value
        m_Lip = Nd.Attributes("Lip").Value
    End Sub
    Public Overrides Sub Write_XML(ByVal Writer As XmlTextWriter)
        MyBase.Write_XML(Writer)
        Writer.WriteAttributeString("BSG", m_BSG)
        Writer.WriteAttributeString("CRP", m_CRP)
        Writer.WriteAttributeString("BiliG", m_BiliG)
        Writer.WriteAttributeString("ALAT", m_ALAT)
        Writer.WriteAttributeString("ASAT", m_ASAT)
        Writer.WriteAttributeString("Amyl", m_Amyl)
        Writer.WriteAttributeString("Lip", m_Lip)
    End Sub

    Public Overrides Sub Write_TypeXML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Typ", "Labor1")
    End Sub

    Property SelfEdited() As Boolean
        Get
            Return m_SelfEdited
        End Get
        Set(ByVal value As Boolean)
            If m_SelfEdited <> value Then
                m_SelfEdited = value
                RaiseEvent SelfEdited_Changed()
            End If
        End Set
    End Property

    Property BSG() As String
        Get
            Return m_BSG
        End Get
        Set(ByVal value As String)
            If m_BSG <> value.Trim Then
                m_BSG = value.Trim
                CreateNewText()
            End If
        End Set
    End Property

     Property CRP() As String
         Get
            Return  m_CRP
         End Get
         Set(ByVal value As String)
            If m_CRP <> value.Trim Then
                m_CRP = value.Trim
                CreateNewText()
            End If
        End Set
     End Property


    Property BiliG() As String
        Get
            Return m_BiliG
        End Get
        Set(ByVal value As String)
            If m_BiliG <> value.Trim Then
                m_BiliG = value.Trim
                CreateNewText()
            End If
        End Set
    End Property


    Property ALAT() As String
        Get
            Return m_ALAT
        End Get
        Set(ByVal value As String)
            If m_ALAT <> value.Trim Then
                m_ALAT = value.Trim
                CreateNewText()
            End If
        End Set
    End Property


    Property ASAT() As String
        Get
            Return m_ASAT
        End Get
        Set(ByVal value As String)
            If m_ASAT <> value.Trim Then
                m_ASAT = value.Trim
                CreateNewText()
            End If
        End Set
    End Property


    Property Amyl() As String
        Get
            Return m_Amyl
        End Get
        Set(ByVal value As String)
            If m_Amyl <> value.Trim Then
                m_Amyl = value.Trim
                CreateNewText()
            End If
        End Set
    End Property


     Property Lip() As String
         Get
            Return  m_Lip
         End Get
         Set(ByVal value As String)
            If m_Lip <> value.Trim Then
                m_Lip = value.Trim
                CreateNewText()
            End If
        End Set
    End Property

    Private Sub CreateNewText()
        Dim TmpText As String = ""
     
        If m_BSG <> "" Then
            TmpText &= ", Blutsenkung " & m_BSG
        End If
        If m_CRP <> "" Then
            TmpText &= ", CRP " & m_CRP
        End If
        If m_BiliG <> "" Then
            TmpText &= ", Gesamt-Bilirubin " & m_BiliG
        End If
        If m_ALAT <> "" Then
            TmpText &= ", ALAT " & m_ALAT
        End If
        If m_ASAT <> "" Then
            TmpText &= ", ASAT " & m_ASAT
        End If
        If m_Amyl <> "" Then
            TmpText &= ", Amylase " & m_Amyl
        End If
        If m_Lip <> "" Then
            TmpText &= ", Lipase " & m_Lip
        End If
        If TmpText <> "" Then
            TmpText = TmpText.Substring(2)
        End If

        If Me.Text <> TmpText Then
            Me.Text = TmpText
            Me.ValidateText()
            RaiseEvent TextChanged()
        End If

    End Sub

    Public Overrides Function IsEmpty() As Boolean
        Return False
    End Function
    Public Overrides Function CreateControl() As IEditorControlItem
        Return New LaborEditorItem(Me, False)
    End Function
    Public Overloads Overrides Function CreateControl(ByVal Expanded As Boolean) As IEditorControlItem
        Return New LaborEditorItem(Me, Expanded)
    End Function
End Class
