Public Class LaborEditorItem
    Implements IEditorControlItem

    Public Event ShouldBeDeleted(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.ShouldBeDeleted
    Public Event WasSelected(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.WasSelected

    Private WithEvents m_Source As LaborBefund
    Private m_Initializing As Boolean = False

    Private m_Expanded As Boolean = True
    Private Sub SetExpanded(ByVal NewValue As Boolean)
        If m_Expanded <> NewValue Then
            m_Expanded = NewValue
            Dim ExtraHeight As Integer = 20
            If m_Expanded Then
                Me.ButtonExpand.Image = My.Resources.AufklappUp
                'Me.Height += ExtraHeight
                Me.PanelWerte.Visible = True

                Me.TextBoxDetails.Multiline = False
                Me.Height = PanelWerte.Height + TextBoxDetails.Height - 1
                Me.TextBoxDetails.Top = PanelWerte.Bottom
            Else
                Me.ButtonExpand.Image = My.Resources.AufklappDown
                Me.PanelWerte.Visible = False
                Me.Height = 39
                Me.TextBoxDetails.Multiline = True
                Me.TextBoxDetails.Height = 40
                Me.TextBoxDetails.Top = -1
                'Me.Height -= ExtraHeight
            End If
        End If

    End Sub
    Private Sub ButtonExpand_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonExpand.Click
        SetExpanded(Not m_Expanded)
    End Sub

    Public ReadOnly Property Source() As ChangeListItem Implements IEditorControlItem.Source
        Get
            Return m_Source
        End Get
    End Property

    Private Sub EditorItem_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        RaiseEvent WasSelected(Me)
    End Sub

    Private Sub Button1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Button1.KeyUp
        If e.KeyCode = Keys.Delete Then
            RaiseEvent ShouldBeDeleted(Me)
        End If
    End Sub

   

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub

    Public Sub New(ByVal Source As LaborBefund, ByVal Expanded As Boolean)
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        Read_Source()
        SetExpanded(Expanded)
    End Sub
    Private Sub Read_Source()
        m_Initializing = True
        Me.TextBoxDetails.Text = m_Source.Text
        Me.CheckBoxWichtig.Checked = m_Source.Wichtig
        Dim MinDatum As New Date(1860, 1, 1)
        If m_Source.Datum < MinDatum Then
            Me.TextBoxDatum.Text = ""
        Else
            Me.TextBoxDatum.Text = m_Source.Datum.ToShortDateString
        End If
        If m_Source.Wichtig Then
            Me.TextBoxDetails.ForeColor = Color.Red
            Me.TextBoxDatum.Highlighted = True
        Else
            Me.TextBoxDetails.ForeColor = Color.Black
            Me.TextBoxDatum.Highlighted = False
        End If

        Me.CheckBoxEditiert.Checked = m_Source.SelfEdited
        Me.TextBoxALAT.Text = m_Source.ALAT
        Me.TextBoxASAT.Text = m_Source.ASAT
        Me.TextBoxAmyl.Text = m_Source.Amyl
        Me.TextBoxBiliG.Text = m_Source.BiliG
        Me.TextBoxBSG.Text = m_Source.BSG
        Me.TextBoxCRP.Text = m_Source.CRP
        Me.TextBoxLip.Text = m_Source.Lip


        If m_Source.SelfEdited Then
            Me.TextBoxALAT.Enabled = False
            Me.TextBoxASAT.Enabled = False
            Me.TextBoxAmyl.Enabled = False
            Me.TextBoxBiliG.Enabled = False
            Me.TextBoxBSG.Enabled = False
            Me.TextBoxCRP.Enabled = False
            Me.TextBoxLip.Enabled = False
        Else
            Me.TextBoxALAT.Enabled = True
            Me.TextBoxASAT.Enabled = True
            Me.TextBoxAmyl.Enabled = True
            Me.TextBoxBiliG.Enabled = True
            Me.TextBoxBSG.Enabled = True
            Me.TextBoxCRP.Enabled = True
            Me.TextBoxLip.Enabled = True
        End If
        m_Initializing = False
    End Sub


    Private Sub m_Source_SelfEdited_Changed() Handles m_Source.SelfEdited_Changed
        m_Initializing = True
        If m_Source.SelfEdited Then
            Me.CheckBoxEditiert.Checked = True
            Me.TextBoxALAT.Enabled = False
            Me.TextBoxASAT.Enabled = False
            Me.TextBoxAmyl.Enabled = False
            Me.TextBoxBiliG.Enabled = False
            Me.TextBoxBSG.Enabled = False
            Me.TextBoxCRP.Enabled = False
            Me.TextBoxLip.Enabled = False
        Else
            Me.CheckBoxEditiert.Checked = False
            Me.TextBoxALAT.Enabled = True
            Me.TextBoxASAT.Enabled = True
            Me.TextBoxAmyl.Enabled = True
            Me.TextBoxBiliG.Enabled = True
            Me.TextBoxBSG.Enabled = True
            Me.TextBoxCRP.Enabled = True
            Me.TextBoxLip.Enabled = True
        End If
        m_Initializing = False
    End Sub

    Private Sub m_Source_TextChanged() Handles m_Source.TextChanged
        m_Initializing = True
        TextBoxDetails.Text = m_Source.Text
        m_Initializing = False
    End Sub

    Private Sub TextBoxDetails_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TextBoxDetails.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Text = TextBoxDetails.Text
        m_Source.SelfEdited = True
    End Sub

    Private Sub CheckBoxEditiert_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxEditiert.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Source.SelfEdited = CheckBoxEditiert.Checked
    End Sub

    Private Sub CheckBoxWichtig_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxWichtig.CheckedChanged
        If m_Initializing Then Exit Sub
        m_Source.Wichtig = CheckBoxWichtig.Checked
        If m_Source.Wichtig Then
            Me.TextBoxDetails.ForeColor = Color.Red
            Me.TextBoxDatum.Highlighted = True
        Else
            Me.TextBoxDetails.ForeColor = Color.Black
            Me.TextBoxDatum.Highlighted = False
        End If
    End Sub


    Private Sub TextBoxDetails_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxDetails.Validating
        If m_Initializing Then Exit Sub
        m_Source.ValidateText()
    End Sub
    Private Sub TextBoxDatum_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxDatum.TextChanged
        Dim Dat As New ParsedDate(TextBoxDatum.Text)
        m_Source.Datum = Dat.Datum
    End Sub
    Private Sub TextBoxDatum_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxDatum.Validating
        If m_Initializing Then Exit Sub
        m_Source.ValidateDatum()
    End Sub

    Private Sub TextBoxBiliG_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBiliG.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.BiliG = TextBoxBiliG.Text
    End Sub

    Private Sub TextBoxALAT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxALAT.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.ALAT = TextBoxALAT.Text
    End Sub

    Private Sub TextBoxASAT_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxASAT.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.ASAT = TextBoxASAT.Text
    End Sub

    Private Sub TextBoxAmyl_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxAmyl.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Amyl = TextBoxAmyl.Text
    End Sub

    Private Sub TextBoxLip_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxLip.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Lip = TextBoxLip.Text
    End Sub

    Private Sub TextBoxBSG_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBSG.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.BSG = TextBoxBSG.Text
    End Sub

    Private Sub TextBoxCRP_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxCRP.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.CRP = TextBoxCRP.Text
    End Sub
End Class
