Public Class MedikamentEditorItem
    Implements IEditorControlItem

    Public Event ShouldBeDeleted(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.ShouldBeDeleted
    Public Event WasSelected(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.WasSelected

    Private m_Source As MedikamentVerordnung
    Private m_Initializing As Boolean = False


    Public ReadOnly Property Source() As ChangeListItem Implements IEditorControlItem.Source
        Get
            Return m_Source
        End Get
    End Property

    Private Sub EditorItem_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        RaiseEvent WasSelected(Me)
    End Sub

    Private Sub Button1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Button1.KeyUp
        If e.KeyCode = Keys.Delete Then
            RaiseEvent ShouldBeDeleted(Me)
        End If
    End Sub


    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub
    Public Sub New(ByVal Source As MedikamentVerordnung)
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        Read_Source()
    End Sub
    Private Sub Read_Source()
        m_Initializing = True
        Me.TextBoxMedikament.Text = m_Source.Medikament
        Me.TextBoxFrueh.Text = m_Source.Frueh
        Me.TextBoxMittag.Text = m_Source.Mittag
        Me.TextBoxAbend.Text = m_Source.Abend
        Me.TextBoxNacht.Text = m_Source.Nacht
        Me.TextBoxHinweise.Text = m_Source.Hinweise
        m_Initializing = False

    End Sub


    Private Sub TextBoxMedikament_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxMedikament.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Medikament = TextBoxMedikament.Text
    End Sub

    Private Sub TextBoxFrueh_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxFrueh.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Frueh = TextBoxFrueh.Text
    End Sub

    Private Sub TextBoxMittag_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxMittag.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Mittag = TextBoxMittag.Text
    End Sub

    Private Sub TextBoxAbend_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxAbend.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Abend = TextBoxAbend.Text
    End Sub

    Private Sub TextBoxNacht_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxNacht.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Nacht = TextBoxNacht.Text
    End Sub

    Private Sub TextBoxHinweise_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxHinweise.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Hinweise = TextBoxHinweise.Text
    End Sub

    Private Sub TextBoxMedikament_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxMedikament.Validating
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxFrueh_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxFrueh.Validating
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxMittag_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxMittag.Validating
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxAbend_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxAbend.Validating
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxNacht_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxNacht.Validating
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxSonderverordnung_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs)
        m_Source.ValidateForNewItem()
    End Sub

    Private Sub TextBoxHinweise_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles TextBoxHinweise.Validating
        m_Source.ValidateForNewItem()
    End Sub
End Class
