Public Class UnterschriftEditorItem
    Implements IEditorControlItem

    Public Event ShouldBeDeleted(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.ShouldBeDeleted
    Public Event WasSelected(ByVal SelectedControl As IEditorControlItem) Implements IEditorControlItem.WasSelected

    Private m_Source As Unterschrift
    Private m_Initializing As Boolean = False


    Public ReadOnly Property Source() As ChangeListItem Implements IEditorControlItem.Source
        Get
            Return m_Source
        End Get
    End Property

    Private Sub EditorItem_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Enter
        RaiseEvent WasSelected(Me)
    End Sub

    Private Sub Button1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Button1.KeyUp
        If e.KeyCode = Keys.Delete Then
            RaiseEvent ShouldBeDeleted(Me)
        End If
    End Sub


    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub
    Public Sub New(ByVal Source As Unterschrift)
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Source = Source
        Read_Source()
    End Sub
    Private Sub Read_Source()
        m_Initializing = True
        Me.ComboBoxDienstgrad.Text = m_Source.Dienstgrad
        Me.TextBoxName.Text = m_Source.Name
        m_Initializing = False

    End Sub


    Private Sub ComboBoxDienstgrad_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxDienstgrad.GotFocus
        ComboBoxDienstgrad.SelectionStart = ComboBoxDienstgrad.Text.Length
        ComboBoxDienstgrad.SelectionLength = 0
    End Sub

    Private Sub ComboBoxDienstgrad_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBoxDienstgrad.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Dienstgrad = ComboBoxDienstgrad.Text
    End Sub

    Private Sub TextBoxName_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxName.TextChanged
        If m_Initializing Then Exit Sub
        m_Source.Name = TextBoxName.Text
    End Sub

    Private Sub UnterschriftEditorItem_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LostFocus
        Me.ComboBoxDienstgrad.SelectionLength = 0
    End Sub

    Private Sub UnterschriftEditorItem_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        Dim RestWidth As Integer = Me.Width - 22
        Dim HalfWidth As Integer = (Me.Width - 22) \ 2 + 1
        Me.TextBoxName.Width = HalfWidth
        Me.ComboBoxDienstgrad.Left = Me.TextBoxName.Left + Me.TextBoxName.Width - 1
        Me.ComboBoxDienstgrad.Width = Me.Width - Me.ComboBoxDienstgrad.Left + 2
        ComboBoxDienstgrad.SelectionLength = 0
    End Sub
End Class
