Public Class GesternHeuteMorgenBefundControl
    Inherits TreeView
    Private WithEvents m_source As BefundTextEintragsListe = Nothing
    Private WithEvents m_UStichworte As BefundStichwortListe
    Private m_Pat As Patient

    Private m_TempText As String = ""

    Public Event NavigateToBefund(ByVal Befund As PatientBefund)

    Public Sub SetSource(ByVal UStichworte As BefundStichwortListe, ByVal Pat As Patient)
        m_UStichworte = UStichworte
        If Pat Is Nothing Then
            m_source = Nothing
            m_Pat = Nothing
        Else
            m_source = Pat.Befunde
            m_Pat = Pat
        End If

        ReadSource()
    End Sub
    Private Sub ReadSource()

        Dim TempNodes As New List(Of TreeNode)
        If m_Pat IsNot Nothing Then
            Dim LowerKategories As New List(Of String)
            For Each wd As BefundStichwort In m_UStichworte
                If wd.GHMAnzeige Then
                    LowerKategories.Add(wd.KurzWort.Trim.ToLower)
                End If
            Next


            Dim Items As New List(Of PatientBefund) '= m_Pat.GetBefunde(BefundSammlungsArten.Gestern)

            Dim Suchdatum As Date = Date.Today.AddDays(-1)
            For Each Bef As BefundTextEintrag In m_Pat.Befunde
                If Bef.Datum.Date = Suchdatum Then
                    Items.Add(New PatientBefund(m_Pat, Bef))
                End If
            Next

            Dim Nd As New TreeNode("Gestern")
            For Each Bef As PatientBefund In Items
                If LowerKategories.Contains(Bef.Befund.Kategorie.ToLower) Then
                    Nd.Nodes.Add(New PatientBefundTreeNode(Bef, False))
                End If
            Next

            TempNodes.Add(Nd)

            Suchdatum = Date.Today
            Items.Clear()  '= m_Pat.GetBefunde(BefundSammlungsArten.Heute)
            For Each Bef As BefundTextEintrag In m_Pat.Befunde
                If Bef.Datum.Date = Suchdatum Then
                    Items.Add(New PatientBefund(m_Pat, Bef))
                End If
            Next

            Nd = New TreeNode("Heute")
            For Each Bef As PatientBefund In Items
                If LowerKategories.Contains(Bef.Befund.Kategorie.ToLower) Then
                    Nd.Nodes.Add(New PatientBefundTreeNode(Bef, False))
                End If
            Next


            TempNodes.Add(Nd)
            Suchdatum = Date.Today.AddDays(1)
            Items.Clear()  '= m_Pat.GetBefunde(BefundSammlungsArten.Heute)
            For Each Bef As BefundTextEintrag In m_Pat.Befunde
                If Bef.Datum.Date = Suchdatum Then
                    Items.Add(New PatientBefund(m_Pat, Bef))
                End If
            Next

            Nd = New TreeNode("Morgen")
            For Each Bef As PatientBefund In Items
                If LowerKategories.Contains(Bef.Befund.Kategorie.ToLower) Then
                    Nd.Nodes.Add(New PatientBefundTreeNode(Bef, False))
                End If
            Next


            TempNodes.Add(Nd)

        End If
        Dim TempText As String = ""
        For Each Nd As TreeNode In TempNodes
            TempText &= Nd.Text
            For Each xNd As TreeNode In Nd.Nodes
                TempText &= xNd.Text
            Next
        Next
        If m_TempText <> TempText Then
            m_TempText = TempText
            Me.Nodes.Clear()
            Me.Nodes.AddRange(TempNodes.ToArray)
            Me.ExpandAll()
        End If
    End Sub

    Private Sub m_source_Changed(ByVal PropertyName As String) Handles m_source.Changed
        ReadSource()
    End Sub

    Private Sub m_UStichworte_Changed() Handles m_UStichworte.Changed
        ReadSource()
    End Sub

    Public Sub New()
        Me.ShowLines = False
        Me.ShowPlusMinus = False
        Me.ShowRootLines = False
        Me.HideSelection = True
    End Sub

    Private Sub GesternHeuteMorgenBefundControl_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles Me.AfterSelect
        Try
            Dim Node As PatientBefundTreeNode = Me.SelectedNode
            RaiseEvent NavigateToBefund(Node.PatBef)
        Catch ex As Exception

        End Try
    End Sub
End Class
