Public Class StammdatenControl

    Private WithEvents m_Source As Patient
    Private m_BMP As Bitmap
    WriteOnly Property Source() As Patient
        Set(ByVal value As Patient)
            m_Source = value
            m_BMP = Nothing
            Invalidate()
        End Set
    End Property
    Public Sub New()

        ' Dieser Aufruf ist für den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fügen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.SetStyle(ControlStyles.DoubleBuffer _
                     Or ControlStyles.UserPaint _
                     Or ControlStyles.AllPaintingInWmPaint, _
                     True)
    End Sub
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        MyBase.OnPaint(e)

        'Benutzerdefinierten Zeichnungscode hier einfügen
        If m_BMP Is Nothing Then
            m_BMP = New Bitmap(Me.Width, Me.Height)
            Dim g As Graphics = Graphics.FromImage(m_BMP)
            g.Clear(Color.White)
            If m_Source IsNot Nothing Then
                Dim BlackBrush As SolidBrush = Brushes.Black
                Dim GrayBrush As SolidBrush = Brushes.Gray
                Dim Ft As Font = Me.Font
                g.DrawString("Name, Vorname", Ft, GrayBrush, 4, 4)
                g.DrawString(m_Source.Nachname & ", " & m_Source.Vorname, Ft, BlackBrush, 12, 18)

                g.DrawString("Geburtsdatum", Ft, GrayBrush, 4, 34)
                g.DrawString("Alter", Ft, GrayBrush, 4, 48)
                Dim MinDatum As New Date(1860, 1, 1)
                If m_Source.Geburtsdatum > MinDatum Then
                    Dim Alter As Integer = DateDiff(DateInterval.Year, m_Source.Geburtsdatum, Date.Today)
                    g.DrawString(m_Source.Geburtsdatum.ToShortDateString, Ft, BlackBrush, 78, 34)
                    g.DrawString(Alter.ToString & " Jahre", Ft, BlackBrush, 78, 48)
                End If


                g.DrawLine(Pens.LightBlue, 4, 64, Me.Width - 4, 64)


                g.DrawString("Aufnahme", Ft, GrayBrush, 4, 78)
                If m_Source.Aufnahmedatum > MinDatum Then
                    g.DrawString(m_Source.Aufnahmedatum.ToShortDateString, Ft, BlackBrush, 78, 78)
                End If

                If m_Source.Entlassungsdatum > MinDatum Then
                    g.DrawString("Entlassung", Ft, GrayBrush, 4, 94)
                    g.DrawString(m_Source.Entlassungsdatum.ToShortDateString, Ft, BlackBrush, 78, 94)
                ElseIf m_Source.Vorgeseheneentlassung > MinDatum Then
                    g.DrawString("Vorgesehene Entlassung", Ft, GrayBrush, 4, 94)
                    g.DrawString(m_Source.Vorgeseheneentlassung.ToShortDateString, Ft, GrayBrush, 94, 108)
                Else
                    g.DrawString("Entlassung", Ft, GrayBrush, 4, 94)
                End If

                g.DrawString("Tage stationär", Ft, GrayBrush, 4, 124)
                Dim TageStationär As Integer = -1
                If m_Source.Aufnahmedatum > MinDatum Then
                    If m_Source.Entlassungsdatum > MinDatum Then
                        TageStationär = DateDiff(DateInterval.Day, m_Source.Aufnahmedatum, m_Source.Entlassungsdatum)
                    Else
                        TageStationär = DateDiff(DateInterval.Day, m_Source.Aufnahmedatum, Date.Today)
                    End If
                End If
                If TageStationär > -1 Then
                    g.DrawString(TageStationär.ToString, Ft, GrayBrush, 78, 124)
                End If

                g.DrawLine(Pens.LightBlue, 4, 138, Me.Width - 4, 138)


                g.DrawString("Ärzte", Ft, GrayBrush, 4, 154)
                Dim Rect As New RectangleF(12, 154, Me.Width - 12, 14)
                Dim SF As New StringFormat(StringFormat.GenericDefault)
                SF.Trimming = StringTrimming.EllipsisCharacter
                For Each Itm As ArztLabel In m_Source.XMLPart.Aerzte
                    Rect.Offset(0, 14)
                    g.DrawString(Itm.KurzText, Ft, GrayBrush, Rect, SF)
                Next

            End If
            ControlPaint.DrawVisualStyleBorder(g, New Rectangle(0, 0, Me.Width - 1, Me.Height - 1))
        End If

        e.Graphics.DrawImage(m_BMP, 0, 0)
    End Sub

  
    Private Sub StammdatenControl_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        m_BMP = Nothing
        Invalidate()
    End Sub

    Private Sub m_Source_Changed() Handles m_Source.Changed
        m_BMP = Nothing
        Invalidate()
    End Sub
End Class
