Imports System.Xml
Public MustInherit Class Adresse

    Public Event Kuerzel_Geaendert()
    Public Event AdressAnsicht_Geaendert()
    Public Event AnredeVorschlaege_Geaendert()
    Public Event Geschlecht_Geaendert()
    Public Event BriefAnrede_Geaendert()

    Public Event BriefAnrede_AutomatischGeaendert()

    Private m_Nachname As String = ""
    Private m_Vorname As String = ""
    Private m_Ort As String = ""
    Private m_Plz As String = ""
    Private m_Strasse As String = ""
    Private m_Firma As String = ""
    Private m_Firma1 As String = ""
    Private m_Stellung As String = ""
    Private m_Geburtsdatum As Date = Date.MinValue
    Private m_Firmavoran As Boolean = True
    Private m_Geschlecht As Geschlechter = Geschlechter.maennlich
    Private m_Titel As String = ""
    Private m_Briefanrede As String = ""
    Private m_FonFax As FonFaxListe

    Private m_Kuerzel As String = ""
    Private m_AdressAnsicht As String = ""
    Private m_Anredevorschlaege As AnredeVorschlagsListe

    Private WithEvents Anreden As AnredeListe


    Property Kuerzel() As String
        Get
            Return m_Kuerzel
        End Get
        Set(ByVal value As String)
            If m_Kuerzel <> value.Trim Then
                m_Kuerzel = value.Trim
                RaiseEvent Kuerzel_Geaendert()
            End If
        End Set
    End Property
    Property AdressAnsicht() As String
        Get
            Return m_AdressAnsicht
        End Get
        Set(ByVal value As String)
            If m_AdressAnsicht <> value.Trim Then
                m_AdressAnsicht = value.Trim
                RaiseEvent AdressAnsicht_Geaendert()
            End If
        End Set
    End Property
    Property Anredevorschlaege() As AnredeVorschlagsListe
        Get
            Return m_Anredevorschlaege
        End Get
        Set(ByVal value As AnredeVorschlagsListe)
            If Not m_Anredevorschlaege.IstGleich(value) Then
                m_Anredevorschlaege = value
                RaiseEvent AnredeVorschlaege_Geaendert()
                Me.Briefanrede = m_Anredevorschlaege.OptimalAnrede
                RaiseEvent BriefAnrede_AutomatischGeaendert()
            End If
        End Set
    End Property

    Property Nachname() As String
        Get
            Return m_Nachname
        End Get
        Set(ByVal Value As String)
            If m_Nachname <> Value.Trim Then
                m_Nachname = Value.Trim
                Create_Kuerzel()
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Vorname() As String
        Get
            Return m_Vorname
        End Get
        Set(ByVal Value As String)
            If m_Vorname <> Value.Trim Then
                m_Vorname = Value.Trim
                Create_Kuerzel()
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Ort() As String
        Get
            Return m_Ort
        End Get
        Set(ByVal Value As String)
            If m_Ort <> Value.Trim Then
                m_Ort = Value.Trim
                Create_Kuerzel()
                Create_AdressAnsicht()
            End If
        End Set
    End Property
    Property PLZ() As String
        Get
            Return m_Plz.Trim
        End Get
        Set(ByVal Value As String)
            If m_Plz <> Value.Trim Then
                m_Plz = Value.Trim
                Create_AdressAnsicht()
            End If
        End Set
    End Property
    Property Strasse() As String
        Get
            Return m_Strasse
        End Get
        Set(ByVal Value As String)
            If m_Strasse <> Value.Trim Then
                m_Strasse = Value.Trim
                Create_AdressAnsicht()
            End If
        End Set
    End Property
    Property Firma() As String
        Get
            Return m_Firma
        End Get
        Set(ByVal Value As String)
            If m_Firma <> Value.Trim Then
                m_Firma = Value.Trim
                Create_Kuerzel()
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Firma1() As String
        Get
            Return m_Firma1
        End Get
        Set(ByVal Value As String)
            If m_Firma1 <> Value.Trim Then
                m_Firma1 = Value.Trim
                Create_Kuerzel()
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Stellung() As String
        Get
            Return m_Stellung
        End Get
        Set(ByVal Value As String)
            If m_Stellung <> Value.Trim Then
                m_Stellung = Value.Trim
                Create_Kuerzel()
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Geburtsdatum() As Date
        Get
            Return m_Geburtsdatum
        End Get
        Set(ByVal value As Date)
            m_Geburtsdatum = value
        End Set
    End Property
    Property FirmaVoran() As Boolean
        Get
            Return m_Firmavoran
        End Get
        Set(ByVal Value As Boolean)
            If m_Firmavoran <> Value Then
                m_Firmavoran = Value
                Create_AdressAnsicht()
            End If
        End Set
    End Property
    Property Geschlecht() As Geschlechter
        Get
            Return m_Geschlecht
        End Get
        Set(ByVal Value As Geschlechter)
            If m_Geschlecht <> Value Then
                m_Geschlecht = Value
                RaiseEvent Geschlecht_Geaendert()
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Titel() As String
        Get
            Return m_Titel
        End Get
        Set(ByVal Value As String)
            If m_Titel <> Value Then
                m_Titel = Value
                Create_AdressAnsicht()
                Create_AnredeVorschlaege()
            End If
        End Set
    End Property
    Property Briefanrede() As String
        Get
            Return m_Briefanrede
        End Get
        Set(ByVal Value As String)
            If m_Briefanrede <> Value Then
                m_Briefanrede = Value
                RaiseEvent BriefAnrede_Geaendert()
            End If
        End Set
    End Property

    ReadOnly Property FonFax() As FonFaxListe
        Get
            Return m_FonFax
        End Get
    End Property
    Public Sub New()
        Anreden = DataProvider.Anreden
        m_FonFax = New FonFaxListe
        m_Anredevorschlaege = DataProvider.Anreden.CreateAnreden(Me)
        Create_AdressAnsicht()
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        Anreden = DataProvider.Anreden
        m_Nachname = Nd.Attributes("Nachname").Value
        m_Vorname = Nd.Attributes("Vorname").Value
        m_Ort = Nd.Attributes("Ort").Value
        m_Plz = Nd.Attributes("Plz").Value
        m_Strasse = Nd.Attributes("Strasse").Value
        m_Firma = Nd.Attributes("Firma").Value
        m_Firma1 = Nd.Attributes("Firma1").Value
        m_Stellung = Nd.Attributes("Stellung").Value
        m_Geburtsdatum = CDate(Nd.Attributes("Geburtsdatum").Value)
        m_Firmavoran = CBool(Nd.Attributes("Firmavoran").Value)
        m_Geschlecht = CType(CInt(Nd.Attributes("Geschlecht").Value), Geschlechter)
        m_Titel = Nd.Attributes("Titel").Value
        m_Briefanrede = Nd.Attributes("Briefanrede").Value
        m_Kuerzel = Nd.Attributes("Kuerzel").Value

        For Each xNd As XmlNode In Nd.ChildNodes
            If xNd.Name = "FonFax" Then
                m_FonFax = New FonFaxListe(xNd)
                Exit For
            End If
        Next
        m_Anredevorschlaege = DataProvider.Anreden.CreateAnreden(Me)
        Create_AdressAnsicht()
    End Sub
    MustOverride Sub WriteExtraAttributes(ByVal Writer As XmlTextWriter)
    Public Overridable Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("Nachname", m_Nachname)
        Writer.WriteAttributeString("Vorname", m_Vorname)
        Writer.WriteAttributeString("Ort", m_Ort)
        Writer.WriteAttributeString("Plz", m_Plz)
        Writer.WriteAttributeString("Strasse", m_Strasse)
        Writer.WriteAttributeString("Firma", m_Firma)
        Writer.WriteAttributeString("Firma1", m_Firma1)
        Writer.WriteAttributeString("Stellung", m_Stellung)
        Writer.WriteAttributeString("Geburtsdatum", m_Geburtsdatum.ToString)
        Writer.WriteAttributeString("Firmavoran", m_Firmavoran.ToString)
        Writer.WriteAttributeString("Geschlecht", CInt(m_Geschlecht).ToString)
        Writer.WriteAttributeString("Titel", m_Titel)
        Writer.WriteAttributeString("Briefanrede", m_Briefanrede)
        Writer.WriteAttributeString("Kuerzel", m_Kuerzel)
        WriteExtraAttributes(Writer)
        Writer.WriteStartElement("FonFax")
        m_FonFax.Write_XML(Writer)
        Writer.WriteEndElement()
    End Sub

    Public Sub Create_Kuerzel()
        Dim z, ZM As String
        ZM = ""
        z = ""
        If m_Nachname <> "" Then
            z = m_Nachname
            If m_Vorname <> "" Then z &= " " & m_Vorname
            If m_Firma <> "" Then z &= " " & m_Firma
        Else
            If m_Firma <> "" Then z &= " " & m_Firma
            If m_Firma1 <> "" Then z &= " " & m_Firma1
            If m_Stellung <> "" Then z &= " " & m_Stellung
        End If

        z = z.Trim

        If m_Ort <> "" Then
            If z <> "" Then
                Dim Teile() As String = z.Split(" ")
                Dim OrtGefunden As Boolean = False
                For Each txt As String In Teile
                    If txt = m_Ort Then
                        OrtGefunden = True
                        Exit For
                    End If
                Next
                If OrtGefunden Then
                    ZM = z
                Else
                    ZM = z & " " & m_Ort
                End If
            Else
                ZM = m_Ort
            End If
        Else
            ZM = z
        End If
        Kuerzel = ZM.Trim
    End Sub
    Private Sub Create_AdressAnsicht()
        Dim ZM As String = "", I As Integer
        Dim Zeilen As New ArrayList

        If m_Firma <> "" Then Zeilen.Add(m_Firma)
        If m_Firma1 <> "" Then Zeilen.Add(m_Firma1)
        If m_Stellung <> "" Then Zeilen.Add(m_Stellung)

        If m_Geschlecht <> Geschlechter.unpersoenlich Then
            Dim txt1 As String
            If m_Geschlecht = Geschlechter.maennlich Then
                txt1 = "Herrn "
            Else
                txt1 = "Frau "
            End If
            If m_Titel <> "" Then txt1 = txt1 & m_Titel & " "
            If m_Vorname <> "" Then txt1 = txt1 & Vorname_auswerten() & " "
            If m_Nachname <> "" Then txt1 = txt1 & m_Nachname
            If m_Firmavoran Then
                Zeilen.Add(txt1)
            Else
                Zeilen.Insert(0, txt1)
            End If
        End If

        If m_Strasse <> "" Then Zeilen.Add(m_Strasse)
        Zeilen.Add("")
        Dim txt2 As String = String.Empty
        If m_Plz <> "" Then txt2 = m_Plz & " "
        If m_Ort <> "" Then txt2 = txt2 & m_Ort

        If txt2 <> "" Then Zeilen.Add(txt2)

        For I = 0 To Zeilen.Count - 1
            ZM = ZM & Zeilen(I) & vbCrLf
        Next

        If ZM <> "" Then
            ZM = ZM.Substring(0, ZM.Length - 1)
        End If

        AdressAnsicht = ZM
    End Sub
    Private Sub Create_AnredeVorschlaege()
        Anredevorschlaege = DataProvider.Anreden.CreateAnreden(Me)
    End Sub

    Private Function Vorname_auswerten() As String
        Dim ZM As String = ""
        Dim I As Integer
        Dim Einfgen As Boolean = True

        Dim VN As String = m_Vorname
        If VN <> "" Then
            For I = 0 To VN.Length - 1
                Select Case Asc(VN.Substring(I, 1))
                    Case 65 To 90, 97 To 122, 196, 228, 214, 246, 220, 252
                        If Einfgen Then
                            ZM = ZM & VN.Substring(I, 1).ToUpper & "."
                            Einfgen = False
                        End If
                    Case 45
                        ZM = ZM & "-"
                        Einfgen = True
                    Case Else
                        Einfgen = True
                End Select
            Next
        End If

        Return ZM
    End Function

    Private Sub Anreden_Geaendert() Handles Anreden.Geaendert
        Create_AnredeVorschlaege()
    End Sub
End Class
