Imports System.Xml
Public Class AnredeListe
    Inherits List(Of Anrede)

    Public Event Geaendert()

    Public Sub New()
        Standard_Anreden_Herstellen()
    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        For Each Kn As XmlNode In Nd.ChildNodes
            If Kn.Name = "Anrede" Then
                Me.Add(New Anrede(Kn))
            End If
        Next
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        For Each A As Anrede In Me
            Writer.WriteStartElement("Anrede")
            A.Write_XML(Writer)
            Writer.WriteEndElement()
        Next
    End Sub
    Public Function CreateAnreden(ByVal Adresse As Adresse) As AnredeVorschlagsListe
        Dim Result As New AnredeVorschlagsListe

        If Adresse.Geschlecht = Geschlechter.unpersoenlich Then
            Result.Anreden.Add("Sehr geehrte Damen und Herren,")
            Result.Anreden.Add("Sehr geehrte Kollegen,")
            Result.Anreden.Add("Liebe Kollegen,")
            Result.OptimalAnrede = Result.Anreden(0)
        Else
            Dim A As Anrede, S As Anrede, Txt As String, Gefunden As Boolean = False
            Dim Testtext As String = Adresse.Firma & " " & Adresse.Firma1 & " " & Adresse.Stellung & " " & Adresse.Titel & " " & Adresse.Nachname

            S = New Anrede

            Dim ZM As String
            For Each A In DataProvider.Anreden
                If Testtext.IndexOf(A.Titel) > -1 Then
                    S = A
                    Gefunden = True
                    Exit For
                End If
                For Each Txt In A.Synonyme
                    If Testtext.IndexOf(Txt) > -1 Then
                        S = A
                        Gefunden = True
                        Exit For
                    End If
                Next
                If Gefunden Then Exit For
            Next
            If Gefunden Then
                If Adresse.Geschlecht = Geschlechter.maennlich Then
                    ZM = S.AnredeMaennlich
                Else
                    ZM = S.AnredeWeiblich
                End If
                If S.MitNachname Then ZM = ZM & " " & Adresse.Nachname
                ZM = ZM & ","
                Result.Anreden.Add(ZM)
                Result.OptimalAnrede = ZM
            End If
            If Adresse.Nachname <> "" Then
                If Adresse.Geschlecht = Geschlechter.maennlich Then
                    ZM = "Sehr geehrter Herr " & Adresse.Nachname & ","
                Else
                    ZM = "Sehr geehrte Frau " & Adresse.Nachname & ","
                End If
            Else
                If Adresse.Geschlecht = Geschlechter.maennlich Then
                    ZM = "Sehr geehrter Herr,"
                Else
                    ZM = "Sehr geehrte Frau,"
                End If
            End If
            If Not Result.Anreden.Contains(ZM) Then
                Result.Anreden.Add(ZM)
            End If
            If Result.OptimalAnrede = "" Then
                Result.OptimalAnrede = ZM
            End If
            If Adresse.Geschlecht = Geschlechter.maennlich Then
                ZM = "Sehr geehrter Herr Kollege,"
            Else
                ZM = "Sehr geehrte Frau Kollegin,"
            End If
            If Not Result.Anreden.Contains(ZM) Then
                Result.Anreden.Add(ZM)
            End If
            If Adresse.Vorname <> "" Then
                If Adresse.Geschlecht = Geschlechter.maennlich Then
                    Result.Anreden.Add("Lieber " & Adresse.Vorname & ",")
                Else
                    Result.Anreden.Add("Liebe " & Adresse.Vorname & ",")
                End If
            End If
        End If

        Return Result
    End Function


    Public Sub Standard_Anreden_Herstellen()
        Me.Clear()

        Dim A As Anrede
        A = New Anrede("Professor", "Sehr geehrter Herr Professor", "Sehr geehrte Frau Professor", True)
        A.Synonyme.Add("Prof.")
        A.Synonyme.Add("Professor")
        A.Synonyme.Add("Professorin")
        Me.Add(A)

        A = New Anrede("Chefarzt", "Sehr geehrter Herr Chefarzt", "Sehr geehrte Frau Chefarzt", True)
        A.Synonyme.Add("ChA")
        A.Synonyme.Add("Chefarzt")
        A.Synonyme.Add("Chefrztin")
        A.Synonyme.Add("Ch")
        A.Synonyme.Add("ChA.")
        A.Synonyme.Add("Ch.")
        Me.Add(A)

        A = New Anrede("Oberarzt", "Sehr geehrter Herr Oberarzt", "Sehr geehrte Frau Oberarzt", True)
        A.Synonyme.Add("OA")
        A.Synonyme.Add("O")
        A.Synonyme.Add("OA.")
        A.Synonyme.Add("O.")
        A.Synonyme.Add("Oberarzt")
        A.Synonyme.Add("Oberrztin")
        Me.Add(A)

        A = New Anrede("Dozent", "Sehr geehrter Herr Dozent", "Sehr geehrte Frau Dozent", True)
        A.Synonyme.Add("Doz.")
        A.Synonyme.Add("Dozent")
        A.Synonyme.Add("Dozentin")
        Me.Add(A)

        A = New Anrede("Privatdozent", "Sehr geehrter Herr Privatdozent", "Sehr geehrte Frau Privatdozent", True)
        A.Synonyme.Add("PD")
        A.Synonyme.Add("Privatdozentin")
        A.Synonyme.Add("P.D.")
        A.Synonyme.Add("Privat-Dozent")
        A.Synonyme.Add("Priv.Doz.")
        A.Synonyme.Add("Priv.-Doz.")
        A.Synonyme.Add("Priv-Doz.")
        A.Synonyme.Add("Priv-Doz")
        A.Synonyme.Add("Privatdozent")
        Me.Add(A)

        A = New Anrede("Medizinalrat", "Sehr geehrter Herr Medizinalrat", "Sehr geehrte Frau Medizinalrat", True)
        A.Synonyme.Add("MR")
        A.Synonyme.Add("Medizinalrat")
        Me.Add(A)

        A = New Anrede("Sanittsrat", "Sehr geehrter Herr Sanittsrat", "Sehr geehrte Frau Sanittsrat", True)
        A.Synonyme.Add("SR")
        A.Synonyme.Add("Sanittsrtin")
        A.Synonyme.Add("Sanittsrat")
        Me.Add(A)

        A = New Anrede("Doktor", "Sehr geehrter Herr Dr.", "Sehr geehrte Frau Dr.", True)
        A.Synonyme.Add("Dr.")
        A.Synonyme.Add("Doktor")
        Me.Add(A)

        A = New Anrede("Dezernent", "Sehr geehrter Herr Dezernent", "Sehr geehrte Frau Dezernentin", True)
        A.Synonyme.Add("Dez.")
        A.Synonyme.Add("Dezernent")
        A.Synonyme.Add("Dezernentin")
        Me.Add(A)

        A = New Anrede("Richter", "Sehr geehrter Herr Richter", "Sehr geehrte Frau Richterin", True)
        A.Synonyme.Add("Richter")
        A.Synonyme.Add("Richterin")
        Me.Add(A)

        A = New Anrede("Rechtsanwalt", "Sehr geehrter Herr Rechtsanwalt", "Sehr geehrte Frau Rechtsanwalt", True)
        A.Synonyme.Add("Rechtsanwalt")
        A.Synonyme.Add("Rechtsanwltin")
        A.Synonyme.Add("RA")
        A.Synonyme.Add("RA.")
        Me.Add(A)

        A = New Anrede("Arzt", "Sehr geehrter Herr Kollege", "Sehr geehrte Frau Kollegin", False)
        A.Synonyme.Add("Arzt")
        A.Synonyme.Add("arzt")
        A.Synonyme.Add("rztin")
        A.Synonyme.Add("rztin")
        A.Synonyme.Add("DM")
        A.Synonyme.Add("Dipl.-med.")
        A.Synonyme.Add("dipl.-med.")
        A.Synonyme.Add("dipl-med")
        A.Synonyme.Add("dipl.med.")
        A.Synonyme.Add("Dipl.med.")
        A.Synonyme.Add("Dipl-med.")
        A.Synonyme.Add("Dipl-med")
        A.Synonyme.Add("Internist")
        A.Synonyme.Add("Allgemeinmed")
        Me.Add(A)

        A = New Anrede("Direktor", "Sehr geehrter Herr Direktor", "Sehr geehrte Frau Direktor", True)
        A.Synonyme.Add("Direktorin")
        A.Synonyme.Add("Dir.")
        A.Synonyme.Add("Direktor")
        Me.Add(A)

        A = New Anrede("Pastor", "Sehr geehrter Herr Pastor", "Sehr geehrte Frau Pastorin", False)
        A.Synonyme.Add("Pastor")
        A.Synonyme.Add("Pastorin")
        Me.Add(A)

        A = New Anrede("Pfarrer", "Sehr geehrter Herr Pfarrer", "Sehr geehrte Frau Pfarrer", True)
        A.Synonyme.Add("Pfarrer")
        A.Synonyme.Add("Pfarrerin")
        Me.Add(A)

        RaiseEvent Geaendert()
    End Sub
    Public Sub RaiseGeaendert()
        RaiseEvent Geaendert()
    End Sub
End Class
