Public Class Arzt
    Implements IAdresse

    Private m_Label As ArztLabel
    Private WithEvents m_XMLPart As ArztXMLPart
    ReadOnly Property Label() As ArztLabel
        Get
            Return m_Label
        End Get
    End Property
    ReadOnly Property XMLPart() As ArztXMLPart
        Get
            Return m_XMLPart
        End Get
    End Property
    Public Sub New(ByVal Label As ArztLabel, ByVal Arzt As ArztXMLPart)
        m_Label = Label
        m_XMLPart = Arzt
        m_Label.Geschlecht = m_XMLPart.Geschlecht
        m_Label.KurzText = m_XMLPart.Kuerzel
    End Sub
    'Private Sub m_XMLPart_LabelChanged(ByVal NewValue As String) Handles m_XMLPart.LabelChanged
    '    m_Label.KurzText = NewValue
    'End Sub



    Public Function CreateClone() As Arzt
        Dim NewXMLPart As ArztXMLPart = m_XMLPart.CreateClone
        Dim NewLabel As ArztLabel = m_Label.CreateClone
        Return New Arzt(NewLabel, NewXMLPart)
    End Function
    Public Sub ReadValues(ByVal Original As Arzt)
        m_Label.ReadValues(Original.Label)
        m_XMLPart.ReadValues(Original.XMLPart)
    End Sub


    Property LabelText() As String
        Get
            Return m_Label.KurzText
        End Get
        Set(ByVal value As String)
            If value.Trim <> "" Then
                If value.Trim <> m_Label.KurzText Then
                    m_Label.KurzText = value.Trim
                End If
            End If
        End Set
    End Property

    Private Sub m_XMLPart_AdressAnsicht_Geaendert() Handles m_XMLPart.AdressAnsicht_Geaendert
        RaiseEvent AdressAnsicht_Geaendert()
    End Sub

    Private Sub m_XMLPart_AnredeVorschlaege_Geaendert() Handles m_XMLPart.AnredeVorschlaege_Geaendert
        RaiseEvent AnredeVorschlaege_Geaendert()
    End Sub

    Private Sub m_XMLPart_BriefAnrede_AutomatischGeaendert() Handles m_XMLPart.BriefAnrede_AutomatischGeaendert
        RaiseEvent BriefAnrede_AutomatischGeaendert()
    End Sub

    Private Sub m_XMLPart_BriefAnrede_Geaendert() Handles m_XMLPart.BriefAnrede_Geaendert
        RaiseEvent BriefAnrede_Geaendert()
    End Sub

    Private Sub m_XMLPart_Geschlecht_Geaendert() Handles m_XMLPart.Geschlecht_Geaendert
        m_Label.Geschlecht = m_XMLPart.Geschlecht
        RaiseEvent Geschlecht_Geaendert()
    End Sub

    Private Sub m_XMLPart_Kuerzel_Geaendert() Handles m_XMLPart.Kuerzel_Geaendert
        m_Label.KurzText = m_XMLPart.Kuerzel
        RaiseEvent Kuerzel_Geaendert()
    End Sub

    Public Event Kuerzel_Geaendert() Implements IAdresse.Kuerzel_Geaendert
    Public Event AdressAnsicht_Geaendert() Implements IAdresse.AdressAnsicht_Geaendert
    Public Event AnredeVorschlaege_Geaendert() Implements IAdresse.AnredeVorschlaege_Geaendert
    Public Event Geschlecht_Geaendert() Implements IAdresse.Geschlecht_Geaendert
    Public Event BriefAnrede_Geaendert() Implements IAdresse.BriefAnrede_Geaendert

    Public Event BriefAnrede_AutomatischGeaendert() Implements IAdresse.BriefAnrede_AutomatischGeaendert

    Property Nachname() As String Implements IAdresse.Nachname
        Get
            Return m_XMLPart.Nachname
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Nachname = Value
        End Set
    End Property
    Property Vorname() As String Implements IAdresse.Vorname
        Get
            Return m_XMLPart.Vorname
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Vorname = Value
        End Set
    End Property
    Property Ort() As String Implements IAdresse.Ort
        Get
            Return m_XMLPart.Ort
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Ort = Value
        End Set
    End Property
    Property PLZ() As String Implements IAdresse.PLZ
        Get
            Return m_XMLPart.PLZ
        End Get
        Set(ByVal Value As String)
            m_XMLPart.PLZ = Value
        End Set
    End Property
    Property Strasse() As String Implements IAdresse.Strasse
        Get
            Return m_XMLPart.Strasse
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Strasse = Value
        End Set
    End Property
    Property Firma() As String Implements IAdresse.Firma
        Get
            Return m_XMLPart.Firma
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Firma = Value
        End Set
    End Property
    Property Firma1() As String Implements IAdresse.Firma1
        Get
            Return m_XMLPart.Firma1
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Firma1 = Value
        End Set
    End Property
    Property Stellung() As String Implements IAdresse.Stellung
        Get
            Return m_XMLPart.Stellung
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Stellung = Value
        End Set
    End Property
    Property Geburtsdatum() As Date Implements IAdresse.Geburtsdatum
        Get
            Return m_XMLPart.Geburtsdatum
        End Get
        Set(ByVal value As Date)
            m_XMLPart.Geburtsdatum = value
        End Set
    End Property
    Property FirmaVoran() As Boolean Implements IAdresse.FirmaVoran
        Get
            Return m_XMLPart.FirmaVoran
        End Get
        Set(ByVal Value As Boolean)
            m_XMLPart.FirmaVoran = Value
        End Set
    End Property
    Property Geschlecht() As Geschlechter Implements IAdresse.Geschlecht
        Get
            Return m_XMLPart.Geschlecht
        End Get
        Set(ByVal Value As Geschlechter)
            m_XMLPart.Geschlecht = Value
        End Set
    End Property
    Property Titel() As String Implements IAdresse.Titel
        Get
            Return m_XMLPart.Titel
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Titel = Value
        End Set
    End Property
    Property Briefanrede() As String Implements IAdresse.Briefanrede
        Get
            Return m_XMLPart.Briefanrede
        End Get
        Set(ByVal Value As String)
            m_XMLPart.Briefanrede = Value
        End Set
    End Property

    ReadOnly Property FonFax() As FonFaxListe Implements IAdresse.FonFax
        Get
            Return m_XMLPart.FonFax
        End Get
    End Property

    Public Property AdressAnsicht() As String Implements IAdresse.AdressAnsicht
        Get
            Return m_XMLPart.AdressAnsicht
        End Get
        Set(ByVal value As String)

        End Set
    End Property

    Public Property Anredevorschlaege() As AnredeVorschlagsListe Implements IAdresse.Anredevorschlaege
        Get
            Return m_XMLPart.Anredevorschlaege
        End Get
        Set(ByVal value As AnredeVorschlagsListe)

        End Set
    End Property

    Public Property Kuerzel() As String Implements IAdresse.Kuerzel
        Get
            Return m_XMLPart.Kuerzel
        End Get
        Set(ByVal value As String)

        End Set
    End Property

End Class
