Imports System.Xml
Public Class ArztLabel
    Implements ILabel

    Public Event Changed() Implements ILabel.Changed
    Public Event Remove() Implements ILabel.Remove
    Private m_ID As String = ""
    Private m_Provider As ArztProvider
    Private m_KurzText As String = ""
    Private m_Geschlecht As Geschlechter = Geschlechter.maennlich


    Public Function CreateClone() As ArztLabel
        Dim Lbl As New ArztLabel(New ArztProvider("jaja"), m_ID)
        Lbl.KurzText = m_KurzText
        Lbl.Geschlecht = m_Geschlecht
        Return Lbl
    End Function
    Public Sub ReadValues(ByVal Original As ArztLabel)
        Me.KurzText = Original.KurzText
        Me.Geschlecht = Original.Geschlecht
    End Sub

    ReadOnly Property ID() As String
        Get
            Return m_ID
        End Get
    End Property
  

    Property KurzText() As String Implements ILabel.KurzText
        Get
            Return m_KurzText
        End Get
        Set(ByVal value As String)
            If m_KurzText <> value.Trim Then
                m_KurzText = value.Trim
                m_Provider.Geaendert = True
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Public Property Geschlecht() As Geschlechter Implements ILabel.Geschlecht
        Get
            Return m_Geschlecht
        End Get
        Set(ByVal value As Geschlechter)
            If m_Geschlecht <> value Then
                m_Geschlecht = value
                m_Provider.Geaendert = True
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Public Sub New(ByVal Provider As ArztProvider, ByVal ID As String)
        m_Provider = Provider
        m_ID = ID
    End Sub
    Public Sub New(ByVal Provider As ArztProvider, ByVal Nd As XmlNode)
        m_Provider = Provider
        m_ID = Nd.Attributes("ID").Value
        m_KurzText = Nd.Attributes("KurzText").Value
        m_Geschlecht = CType(CInt(Nd.Attributes("Geschlecht").Value), Geschlechter)
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("ID", m_ID)
        Writer.WriteAttributeString("KurzText", m_KurzText)
        Writer.WriteAttributeString("Geschlecht", CInt(m_Geschlecht).ToString)
    End Sub
    Public Sub SetActive() Implements ILabel.SetActive
        If m_Provider.ActiveEditArzt Is Nothing OrElse m_Provider.ActiveEditArzt.Label IsNot Me Then
            m_Provider.SetActive(Me)
        End If
    End Sub
    Public Sub RemoveFromLists()
        RaiseEvent Remove()
    End Sub

End Class
