Imports System.Xml
Public Class ArztProvider
    Inherits List(Of ArztLabel)

    Public Event ActiveArztGeaendert()
    Public Event ActiveArztAdded()

    Private m_ActiveEditArzt As Arzt = Nothing
    Private m_BasePath As String = ""
    Private m_Geaendert As Boolean = False
    Property Geaendert() As Boolean
        Get
            Return m_Geaendert
        End Get
        Set(ByVal value As Boolean)
            m_Geaendert = value
        End Set
    End Property
    ReadOnly Property ActiveEditArzt() As Arzt
        Get
            Return m_ActiveEditArzt
        End Get
    End Property
    Public Sub New(ByVal BasePath As String)
        m_BasePath = BasePath

        Dim Pfad As String = m_BasePath & "\" & "Aerzte.xml"

        If IO.File.Exists(Pfad) Then

            Dim Nd As XmlNode = DataProvider.GetXML(Pfad)

            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Label" Then
                    Me.Add(New ArztLabel(Me, xNd))
                End If
            Next
        End If
    End Sub

    Public Sub SetActive(ByVal Label As ArztLabel)
        If Label Is Nothing Then
            If m_ActiveEditArzt IsNot Nothing Then
                ActiveEditArzt_Speichern
                m_ActiveEditArzt = Nothing
                RaiseEvent ActiveArztGeaendert()
            End If
        Else
            If m_ActiveEditArzt Is Nothing Then
                Dim NewArzt As ArztXMLPart = CreateArztXMLPart(m_BasePath & "\" & Label.ID & ".xml")
                m_ActiveEditArzt = New Arzt(Label, NewArzt)
                RaiseEvent ActiveArztGeaendert()
            Else
                If m_ActiveEditArzt.Label IsNot Label Then
                    ActiveEditArzt_Speichern
                    Dim NewArzt As ArztXMLPart = CreateArztXMLPart(m_BasePath & "\" & Label.ID & ".xml")
                    m_ActiveEditArzt = New Arzt(Label, NewArzt)
                    RaiseEvent ActiveArztGeaendert()
                End If
            End If
        End If
        Speichern()
    End Sub
    Private Function CreateArztXMLPart(ByVal Pfad As String) As ArztXMLPart
        If IO.File.Exists(Pfad) Then
            Dim Nd As XmlNode = DataProvider.GetXML(Pfad)
            Return New ArztXMLPart(Nd)
        Else
            Return New ArztXMLPart
        End If
    End Function
    Private Sub ActiveEditArzt_Speichern()
        If m_ActiveEditArzt.Label.KurzText <> "" Then
            Dim Writer As XmlTextWriter = DataProvider.GetWriter(m_BasePath & "\" & m_ActiveEditArzt.Label.ID & ".xml")
            m_ActiveEditArzt.XMLPart.Write_XML(Writer)
            DataProvider.CloseWriter(Writer)
        End If
    End Sub
    Public Sub CreateNewArzt()

        Dim Lbl As New ArztLabel(Me, Guid.NewGuid.ToString)

        Dim NewXMLPart As ArztXMLPart = CreateArztXMLPart(m_BasePath & "\" & Lbl.ID & ".xml")
        Dim NewArzt As New Arzt(Lbl, NewXMLPart)

        Dim frm As New frm_Arzt_Bearbeiten(NewArzt)
        frm.Text = "Neuen Arzt anlegen"
        If frm.ShowDialog = DialogResult.OK Then
            If m_ActiveEditArzt IsNot Nothing Then
                ActiveEditArzt_Speichern()
            End If

            Me.Add(Lbl)
            m_ActiveEditArzt = NewArzt
            RaiseEvent ActiveArztAdded()
        End If
    End Sub
    Public Sub AddNew_From_XMLPart(ByVal NewXMLPart As ArztXMLPart)
        NewXMLPart.Create_Kuerzel()
        Dim Lbl As New ArztLabel(Me, Guid.NewGuid.ToString)
        Dim NewArzt As New Arzt(Lbl, NewXMLPart)
        If m_ActiveEditArzt IsNot Nothing Then
            ActiveEditArzt_Speichern()
        End If
        Me.Add(Lbl)
        m_ActiveEditArzt = NewArzt
        RaiseEvent ActiveArztAdded()
    End Sub

    Public Sub EditActiveArzt()
        If m_ActiveEditArzt Is Nothing Then Exit Sub

        Dim Clone As Arzt = m_ActiveEditArzt.CreateClone

        Dim frm As New frm_Arzt_Bearbeiten(Clone)
        frm.Text = "Arzt bearbeiten"
        If frm.ShowDialog = DialogResult.OK Then
            m_ActiveEditArzt.ReadValues(Clone)

        End If
    End Sub
    Public Sub DeleteActiveArzt()
        If m_ActiveEditArzt IsNot Nothing Then
            Dim MyArzt As Arzt = m_ActiveEditArzt
            Dim Pfad As String = m_BasePath & "\" & MyArzt.Label.ID & ".xml"
            If IO.File.Exists(Pfad) Then
                IO.File.Delete(Pfad)
            End If
            MyArzt.Label.RemoveFromLists()
            If DataProvider.PatientProvider.ActiveEditPatient IsNot Nothing Then
                Dim Pat As Patient = DataProvider.PatientProvider.ActiveEditPatient
                If Pat.XMLPart.Aerzte.Contains(MyArzt.Label) Then
                    Pat.XMLPart.Aerzte.Remove(MyArzt.Label)
                End If
            End If
            Me.Remove(MyArzt.Label)
            m_ActiveEditArzt = Nothing
            m_Geaendert = True
            Speichern()
            RaiseEvent ActiveArztGeaendert()
        End If
    End Sub
    Public Sub Speichern()
        If m_Geaendert Then

            Dim Pfad As String = m_BasePath & "\" & "Aerzte.xml"

            Dim Writer As XmlTextWriter = DataProvider.GetWriter(Pfad)

            For Each Lbl As ArztLabel In Me
                If Not Lbl.KurzText = "" Then
                    Writer.WriteStartElement("Label")
                    Lbl.Write_XML(Writer)
                    Writer.WriteEndElement()
                End If
            Next

            DataProvider.CloseWriter(Writer)
            m_Geaendert = False
        End If

    End Sub
    Public Sub SaveAll()
        Speichern()
        If m_ActiveEditArzt IsNot Nothing Then
            ActiveEditArzt_Speichern()
        End If
    End Sub
End Class
