Imports System.Xml
Public Class DataProvider
    Private Shared m_PatientProvider As PatientProvider
    Private Shared m_ArztProvider As ArztProvider
    Private Shared m_Anreden As AnredeListe
    Private Shared m_Titel As TitelListe
    Private Shared m_DataPath As String = ""
    Private Shared m_BriefePath As String = ""
    Private Shared m_TempBriefePath As String = ""
    Private Shared m_Visiten As VisitenSammlung

    Private Shared m_BefundStichworte As BefundStichwortListe
    Private Shared m_DiagnoseStichworte As New DiagnoseStichwortListe

    Private Shared m_Aufgaben As TextEintragsListe
    Private Shared m_Tipps As TextEintragsListe
    Private Shared m_Unterschriften As UnterschriftsListe

    Private Shared m_SuchEinstellungen As SuchEinstellungen

    Shared ReadOnly Property DataPath() As String
        Get
            Return m_DataPath
        End Get
    End Property
    Shared ReadOnly Property BriefePath() As String
        Get
            Return m_BriefePath
        End Get
    End Property
    Shared ReadOnly Property TempBriefePath() As String
        Get
            Return m_TempBriefePath
        End Get
    End Property
    Shared ReadOnly Property Unterschriften() As UnterschriftsListe
        Get
            Return m_Unterschriften
        End Get
    End Property
    Shared ReadOnly Property SuchEinstellungen() As SuchEinstellungen
        Get
            Return m_SuchEinstellungen
        End Get
    End Property
    Shared ReadOnly Property BefundStichworte() As BefundStichwortListe
        Get
            Return m_BefundStichworte
        End Get
    End Property
    Shared ReadOnly Property DiagnoseStichworte() As DiagnoseStichwortListe
        Get
            Return m_DiagnoseStichworte
        End Get
    End Property
    Shared ReadOnly Property Aufgaben() As TextEintragsListe
        Get
            Return m_Aufgaben
        End Get
    End Property
    Shared ReadOnly Property Tipps() As TextEintragsListe
        Get
            Return m_Tipps
        End Get
    End Property
    Shared ReadOnly Property PatientProvider() As PatientProvider
        Get
            Return m_PatientProvider
        End Get
    End Property
    Shared ReadOnly Property ArztProvider() As ArztProvider
        Get
            Return m_ArztProvider
        End Get
    End Property
    Shared ReadOnly Property Anreden() As AnredeListe
        Get
            Return m_Anreden
        End Get
    End Property
    Shared ReadOnly Property Titel() As TitelListe
        Get
            Return m_Titel
        End Get
    End Property
    Shared Property Visiten() As VisitenSammlung
        Get
            Return m_Visiten
        End Get
        Set(ByVal value As VisitenSammlung)
            m_Visiten = value
        End Set
    End Property

    Shared Sub VorlageDaten_Uebernehmen()
        Dim VBasePath As String = Application.StartupPath & "\" & "VorlageDaten"
        Dim VAerztePath As String = VBasePath & "\Aerzte"
        Dim VPatientenPath As String = VBasePath & "\Patienten"
        Dim VDataPath As String = VBasePath & "\Data"
        Dim VBriefePath As String = VBasePath & "\Briefe"

        Dim BasePath As String = Application.StartupPath & "\" & "Daten"
        Dim AerztePath As String = BasePath & "\Aerzte"
        Dim PatientenPath As String = BasePath & "\Patienten"
        Dim DataPath As String = BasePath & "\Data"
        Dim BriefePath As String = BasePath & "\Briefe"

        If Not IO.Directory.Exists(AerztePath) Then
            IO.Directory.CreateDirectory(AerztePath)
        End If
        If Not IO.Directory.Exists(PatientenPath) Then
            IO.Directory.CreateDirectory(PatientenPath)
        End If
        If Not IO.Directory.Exists(DataPath) Then
            IO.Directory.CreateDirectory(DataPath)
        End If
        If Not IO.Directory.Exists(BriefePath) Then
            IO.Directory.CreateDirectory(BriefePath)
        End If
        'IO.File.Copy(VDataPath & "\BaseData.xml", DataPath & "\BaseData.xml")
        Dim FileNames() As String

        FileNames = IO.Directory.GetFiles(VDataPath)
        For Each txt As String In FileNames
            IO.File.Copy(txt, DataPath & "\" & IO.Path.GetFileName(txt))
        Next

        FileNames = IO.Directory.GetFiles(VAerztePath)
        For Each txt As String In FileNames
            IO.File.Copy(txt, AerztePath & "\" & IO.Path.GetFileName(txt))
        Next

        FileNames = IO.Directory.GetFiles(VPatientenPath)
        For Each txt As String In FileNames
            IO.File.Copy(txt, PatientenPath & "\" & IO.Path.GetFileName(txt))
        Next

        FileNames = IO.Directory.GetFiles(VBriefePath)
        For Each txt As String In FileNames
            IO.File.Copy(txt, BriefePath & "\" & IO.Path.GetFileName(txt))
        Next
    End Sub
    Shared Sub New()
        Dim ErstInstallation As Boolean = False
        Dim BasePath As String = Application.StartupPath & "\" & "Daten"
        If Not IO.Directory.Exists(BasePath) Then
            IO.Directory.CreateDirectory(BasePath)
            VorlageDaten_Uebernehmen()
            ErstInstallation = True
        End If
        Dim AerztePath As String = BasePath & "\Aerzte"
        If Not IO.Directory.Exists(AerztePath) Then
            IO.Directory.CreateDirectory(AerztePath)
        End If
        Dim PatientenPath As String = BasePath & "\Patienten"
        If Not IO.Directory.Exists(PatientenPath) Then
            IO.Directory.CreateDirectory(PatientenPath)
        End If
        m_BriefePath = BasePath & "\Briefe"
        If Not IO.Directory.Exists(m_BriefePath) Then
            IO.Directory.CreateDirectory(m_BriefePath)
        End If
        m_TempBriefePath = m_BriefePath & "\Temp"
        If Not IO.Directory.Exists(m_TempBriefePath) Then
            IO.Directory.CreateDirectory(m_TempBriefePath)
        End If

        m_DataPath = BasePath & "\Data"
        If Not IO.Directory.Exists(m_DataPath) Then
            IO.Directory.CreateDirectory(m_DataPath)
        End If

        m_PatientProvider = New PatientProvider(PatientenPath)
        m_ArztProvider = New ArztProvider(AerztePath)

        If IO.File.Exists(m_DataPath & "\BaseData.xml") Then
            Dim Nd As XmlNode = DataProvider.GetXML(m_DataPath & "\BaseData.xml")

            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Anreden" Then
                    m_Anreden = New AnredeListe(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Titel" Then
                    m_Titel = New TitelListe(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Visiten" Then
                    m_Visiten = New VisitenSammlung(xNd)
                    Exit For
                End If
            Next

            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "BefundStichworte" Then
                    m_BefundStichworte = New BefundStichwortListe(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "DiagnoseStichworte" Then
                    m_DiagnoseStichworte = New DiagnoseStichwortListe(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Aufgaben" Then
                    m_Aufgaben = New TextEintragsListe(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Tipps" Then
                    m_Tipps = New TextEintragsListe(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "SuchEinstellungen" Then
                    m_SuchEinstellungen = New SuchEinstellungen(xNd)
                    Exit For
                End If
            Next
            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Unterschriften" Then
                    m_Unterschriften = New UnterschriftsListe(xNd)
                    Exit For
                End If
            Next
            'For Each xNd As XmlNode In Nd.ChildNodes
            '    If xNd.Name = "Einstellungen" Then
            '        m_LastPrintAufgabe = CInt(xNd.Attributes("LastPrintAufgabe").Value)
            '        Exit For
            '    End If
            'Next

            If m_Unterschriften Is Nothing Then
                m_Unterschriften = New UnterschriftsListe
            End If

            If ErstInstallation Then
                Dim DiffTage As Integer = DateDiff(DateInterval.Day, New Date(2007, 3, 23), Date.Today)

                For Each Lbl As PatientLabel In m_PatientProvider
                    m_PatientProvider.SetActive(Lbl)
                    m_PatientProvider.ActiveEditPatient.Geburtsdatum = m_PatientProvider.ActiveEditPatient.Geburtsdatum.AddDays(DiffTage)
                    m_PatientProvider.ActiveEditPatient.Aufnahmedatum = m_PatientProvider.ActiveEditPatient.Aufnahmedatum.AddDays(DiffTage)

                    For Each Bef As BefundTextEintrag In m_PatientProvider.ActiveEditPatient.Befunde
                        If Not Bef.IsEmpty Then
                            Bef.Datum = Bef.Datum.AddDays(DiffTage)
                        End If
                    Next
                Next
                m_PatientProvider.SetActive(Nothing)
            End If
        Else
            m_Anreden = New AnredeListe
            m_Titel = New TitelListe
            m_Visiten = New VisitenSammlung

            m_BefundStichworte = New BefundStichwortListe
            m_Aufgaben = New TextEintragsListe
            m_Tipps = New TextEintragsListe
            m_SuchEinstellungen = New SuchEinstellungen
            m_Unterschriften = New UnterschriftsListe
        End If
        If m_Unterschriften.Count = 1 Then
            Dim US As New Unterschrift(m_Unterschriften)
            m_Unterschriften.Insert(0, US)
            US.Dienstgrad = "AIW"
            US.Name = "Max Muster"
        End If
    End Sub
    Shared Sub SaveAll()
        m_PatientProvider.SaveAll()
        m_ArztProvider.SaveAll()

        Dim Writer As XmlTextWriter = GetWriter(m_DataPath & "\BaseData.xml")

        Writer.WriteStartElement("Anreden")
        m_Anreden.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("Titel")
        m_Titel.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("Visiten")
        m_Visiten.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("BefundStichworte")
        m_BefundStichworte.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("DiagnoseStichworte")
        m_DiagnoseStichworte.Write_XML(Writer)
        Writer.WriteEndElement()

        Writer.WriteStartElement("Aufgaben")
        m_Aufgaben.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("Tipps")
        m_Tipps.Write_XML(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("SuchEinstellungen")
        m_SuchEinstellungen.Write_Xml(Writer)
        Writer.WriteEndElement()
        Writer.WriteStartElement("Unterschriften")
        m_Unterschriften.Write_XML(Writer)
        Writer.WriteEndElement()


        'Writer.WriteStartElement("Einstellungen")
        'Writer.WriteAttributeString("LastPrintAufgabe", m_LastPrintAufgabe.ToString)
        'Writer.WriteEndElement()

        CloseWriter(Writer)

        RemoveTempBriefe()

    End Sub
    Shared Sub RemoveTempBriefe()
        Dim FileNames() As String = IO.Directory.GetFiles(m_TempBriefePath)
        For Each txt As String In FileNames
            Try
                IO.File.Delete(txt)
            Catch ex As Exception

            End Try
        Next
    End Sub
    Shared Function GetFreeFilePath(ByVal OriginalPath As String) As String
        If Not IO.File.Exists(OriginalPath) Then
            Return OriginalPath
        End If

        Dim BasePath As String = IO.Path.GetDirectoryName(OriginalPath)
        Dim Extension As String = IO.Path.GetExtension(OriginalPath)
        Dim FileName As String = IO.Path.GetFileNameWithoutExtension(OriginalPath)

        Dim NeuPfad As String = OriginalPath
        Dim Zaehler As Integer = 0
        While IO.File.Exists(NeuPfad)
            Zaehler += 1
            NeuPfad = BasePath & "\" & FileName & Zaehler.ToString & Extension
        End While

        Return NeuPfad
    End Function
    Shared Function GetWriter(ByVal Pfad As String) As XmlTextWriter
        Dim Writer As New XmlTextWriter(Pfad, System.Text.Encoding.UTF8)
        Writer.WriteStartDocument(True)

        Writer.WriteStartElement("Elemente")
        Writer.WriteStartElement("Content")
        Return Writer
    End Function
    Shared Sub CloseWriter(ByVal Writer As XmlTextWriter)
        Writer.WriteEndElement()
        Writer.WriteEndElement()
        Writer.WriteEndDocument()
        Writer.Close()
    End Sub

    Shared Function GetXML(ByVal Pfad As String) As XmlNode
        Dim reader As XmlTextReader = New XmlTextReader(Pfad)

        reader.WhitespaceHandling = WhitespaceHandling.None
        Dim xmlDoc As XmlDocument = New XmlDocument
        xmlDoc.Load(reader)
        reader.Close()

        Dim xnod As XmlNode = xmlDoc.DocumentElement

        Return xnod.ChildNodes(0)
    End Function

    Shared Sub EditUnterschriften()
        Dim frm As New frm_Unterschriften_Bearbeiten(m_Unterschriften)
        If frm.ShowDialog = DialogResult.OK Then
            m_Unterschriften = frm.Unterschriften
        End If
    End Sub
End Class
