Imports System.Xml
Public Class PatientLabel
    Implements ILabel
    Implements IPatientDisplayElement

    Public Event Changed() Implements ILabel.Changed
    Public Event Remove() Implements ILabel.Remove

    Private m_Provider As PatientProvider

    Private m_ID As String = ""
    Private m_Entlassungsdatum As Date = Date.MinValue
    Private m_Zimmernummer As String = ""
    Private m_Bettnummer As Integer = 0
    Private m_BettSortnummer As Integer = 0
    Private m_Erhalten As Boolean = False
    Private m_KurzText As String = ""
    Private m_Geschlecht As Geschlechter = Geschlechter.maennlich

    Public Function CreateClone() As PatientLabel
        Dim Lbl As New PatientLabel(New PatientProvider("jaja"), m_ID)
        Lbl.Entlassungsdatum = m_Entlassungsdatum
        Lbl.Zimmernummer = m_Zimmernummer
        Lbl.Bettnummer = m_Bettnummer
        Lbl.BettSortnummer = m_BettSortnummer
        Lbl.Erhalten = m_Erhalten
        Lbl.KurzText = m_KurzText
        Lbl.Geschlecht = m_Geschlecht
        Return Lbl
    End Function
    Public Sub ReadValues(ByVal Original As PatientLabel)
        Me.Entlassungsdatum = Original.Entlassungsdatum
        Me.Zimmernummer = Original.Zimmernummer
        Me.Bettnummer = Original.Bettnummer
        Me.BettSortnummer = Original.BettSortnummer
        Me.Erhalten = Original.Erhalten
        Me.KurzText = Original.KurzText
        Me.Geschlecht = Original.Geschlecht
    End Sub

    Property ID() As String
        Get
            Return m_ID
        End Get
        Set(ByVal value As String)
            m_ID = value
        End Set
    End Property

    Property Entlassungsdatum() As Date
        Get
            Return m_Entlassungsdatum
        End Get
        Set(ByVal value As Date)
            m_Entlassungsdatum = value
            m_Provider.Geaendert = True
        End Set
    End Property
    Property Zimmernummer() As String
        Get
            Return m_Zimmernummer
        End Get
        Set(ByVal value As String)
            m_Zimmernummer = value.Trim
            m_Provider.Geaendert = True
        End Set
    End Property
    Property Bettnummer() As Integer
        Get
            Return m_Bettnummer
        End Get
        Set(ByVal value As Integer)
            m_Bettnummer = value
            m_Provider.Geaendert = True
        End Set
    End Property
    Property BettSortnummer() As Integer
        Get
            Return m_BettSortnummer
        End Get
        Set(ByVal value As Integer)
            m_BettSortnummer = value
            m_Provider.Geaendert = True
        End Set
    End Property
    Property Erhalten() As Boolean
        Get
            Return m_Erhalten
        End Get
        Set(ByVal value As Boolean)
            m_Erhalten = value
            m_Provider.Geaendert = True
        End Set
    End Property

    Property KurzText() As String Implements ILabel.KurzText
        Get
            Return m_KurzText
        End Get
        Set(ByVal value As String)
            If m_KurzText <> value.Trim Then
                m_KurzText = value.Trim
                m_Provider.Geaendert = True
                RaiseEvent Changed()
            End If
        End Set
    End Property

    Public Property Geschlecht() As Geschlechter Implements ILabel.Geschlecht
        Get
            Return m_Geschlecht
        End Get
        Set(ByVal value As Geschlechter)
            If m_Geschlecht <> value Then
                m_Geschlecht = value
                m_Provider.Geaendert = True
                RaiseEvent Changed()
            End If
        End Set
    End Property
    Public Function ThumbNail() As Image
        If m_Geschlecht = Geschlechter.maennlich Then
            Return My.Resources.Mann
        ElseIf m_Geschlecht = Geschlechter.weiblich Then
            Return My.Resources.Frau
        Else
            Return My.Resources.unpers
        End If
    End Function
    Public Sub New(ByVal Provider As PatientProvider, ByVal ID As String)
        m_Provider = Provider
        m_ID = ID
    End Sub
    Public Sub New(ByVal Provider As PatientProvider, ByVal Nd As XmlNode)
        m_Provider = Provider
        m_ID = Nd.Attributes("ID").Value
        m_KurzText = Nd.Attributes("KT").Value
        m_Geschlecht = CType(CInt(Nd.Attributes("G").Value), Geschlechter)

        m_Entlassungsdatum = CDate(Nd.Attributes("ED").Value)
        m_Zimmernummer = Nd.Attributes("ZNr").Value
        m_Bettnummer = CInt(Nd.Attributes("BNr").Value)
        m_BettSortnummer = CInt(Nd.Attributes("BSNr").Value)
        m_Erhalten = CBool(Nd.Attributes("E").Value)

    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        Writer.WriteAttributeString("ID", m_ID)
        Writer.WriteAttributeString("KT", m_KurzText)
        Writer.WriteAttributeString("G", CInt(m_Geschlecht).ToString)

        Writer.WriteAttributeString("ED", m_Entlassungsdatum.ToString)
        Writer.WriteAttributeString("ZNr", m_Zimmernummer)
        Writer.WriteAttributeString("BNr", m_Bettnummer.ToString)
        Writer.WriteAttributeString("BSNr", m_BettSortnummer.ToString)
        Writer.WriteAttributeString("E", m_Erhalten.ToString)
    End Sub
    Public Sub SetActive() Implements ILabel.SetActive
        If m_Provider.ActiveEditPatient Is Nothing OrElse m_Provider.ActiveEditPatient.Label IsNot Me Then
            m_Provider.SetActive(Me)
        End If
    End Sub
    Public Sub RemoveFromLists()
        RaiseEvent Remove()
    End Sub

    Public ReadOnly Property DisplayTitle() As String Implements IPatientDisplayElement.DisplayTitle
        Get
            Return m_KurzText
        End Get
    End Property

    Public ReadOnly Property IsPatientLabel() As Boolean Implements IPatientDisplayElement.IsPatientLabel
        Get
            Return True
        End Get
    End Property
End Class

