Imports System.Xml
Public Class PatientProvider
    Inherits List(Of PatientLabel)

    Public Event ActivePatientGeaendert()
    Public Event ActivePatientAdded()

    Private m_ActiveEditPatient As Patient = Nothing
    Private m_BasePath As String = ""
    Private m_Geaendert As Boolean = False

  

    Property Geaendert() As Boolean
        Get
            Return m_Geaendert
        End Get
        Set(ByVal value As Boolean)
            m_Geaendert = value
        End Set
    End Property
    Public Sub New(ByVal BasePath As String)
        m_BasePath = BasePath

        Dim Pfad As String = m_BasePath & "\" & "Patienten.xml"

        If IO.File.Exists(Pfad) Then
            Dim Nd As XmlNode = DataProvider.GetXML(Pfad)

            For Each xNd As XmlNode In Nd.ChildNodes
                If xNd.Name = "Label" Then
                    Me.Add(New PatientLabel(Me, xNd))
                End If
            Next
        End If


    End Sub
    ReadOnly Property ActiveEditPatient() As Patient
        Get
            Return m_ActiveEditPatient
        End Get
    End Property

    Public Sub SetActive(ByVal Label As PatientLabel)
        If Label Is Nothing Then
            If m_ActiveEditPatient IsNot Nothing Then
                ActiveEditPatient_Speichern()
                m_ActiveEditPatient = Nothing
                RaiseEvent ActivePatientGeaendert()
            End If
        Else
            If m_ActiveEditPatient Is Nothing Then
                Dim NewPatient As PatientXMLPart = CreatePatientXMLPart(m_BasePath & "\" & Label.ID & ".xml")
                m_ActiveEditPatient = New Patient(Label, NewPatient)
                RaiseEvent ActivePatientGeaendert()
            Else
                If m_ActiveEditPatient.Label IsNot Label Then
                    ActiveEditPatient_Speichern()
                    Dim NewPatient As PatientXMLPart = CreatePatientXMLPart(m_BasePath & "\" & Label.ID & ".xml")
                    m_ActiveEditPatient = New Patient(Label, NewPatient)
                    RaiseEvent ActivePatientGeaendert()
                End If
            End If
        End If
        Speichern()
    End Sub
    Private Function CreatePatientXMLPart(ByVal Pfad As String) As PatientXMLPart
        If IO.File.Exists(Pfad) Then
            Dim Nd As XmlNode = DataProvider.GetXML(Pfad)
            Return New PatientXMLPart(Nd, DataProvider.ArztProvider)
        Else
            Return New PatientXMLPart
        End If
    End Function
    Private Sub ActiveEditPatient_Speichern()
        If m_ActiveEditPatient.Label.KurzText <> "" Then
            Dim Writer As XmlTextWriter = DataProvider.GetWriter(m_BasePath & "\" & m_ActiveEditPatient.Label.ID & ".xml")
            m_ActiveEditPatient.XMLPart.Write_XML(Writer)
            DataProvider.CloseWriter(Writer)
        End If
    End Sub
    Public Function GetTempPatient(ByVal Lbl As PatientLabel) As Patient
        If m_ActiveEditPatient IsNot Nothing AndAlso Lbl Is m_ActiveEditPatient.Label Then
            Return m_ActiveEditPatient
        Else
            Dim Pfad As String = m_BasePath & "\" & Lbl.ID & ".xml"
            Dim NewPatient As PatientXMLPart = CreatePatientXMLPart(m_BasePath & "\" & Lbl.ID & ".xml")
            Return (New Patient(Lbl, NewPatient))
        End If
    End Function

    Public Sub CreateNewPatient(Optional ByVal ZimmerNr As String = "", Optional ByVal BettID As Integer = -1)
        Dim Lbl As New PatientLabel(Me, Guid.NewGuid.ToString)
        Dim NewXMLPart As PatientXMLPart = CreatePatientXMLPart(m_BasePath & "\" & Lbl.ID & ".xml")
        Dim NewPatient As New Patient(Lbl, NewXMLPart)

        If ZimmerNr <> "" Then
            NewPatient.Label.Zimmernummer = ZimmerNr
        End If
        If BettID <> -1 Then
            NewPatient.Label.Bettnummer = BettID
        End If
        NewPatient.Aufnahmedatum = Date.Today

        Dim frm As New frm_Stammdaten_Bearbeiten(NewPatient)
        frm.Text = "Neuen Patienten aufnehmen"
        If frm.ShowDialog = DialogResult.OK Then
            If m_ActiveEditPatient IsNot Nothing Then
                ActiveEditPatient_Speichern()
            End If

            Me.Add(Lbl)
            m_ActiveEditPatient = NewPatient
            RaiseEvent ActivePatientAdded()
        End If
    End Sub
    Public Sub CreateNewEmptyPatient()
        Dim Lbl As New PatientLabel(Me, Guid.NewGuid.ToString)
        Dim NewXMLPart As PatientXMLPart = CreatePatientXMLPart(m_BasePath & "\" & Lbl.ID & ".xml")
        Dim NewPatient As New Patient(Lbl, NewXMLPart)

        NewPatient.Aufnahmedatum = Date.Today

       
        If m_ActiveEditPatient IsNot Nothing Then
            ActiveEditPatient_Speichern()
        End If

        Me.Add(Lbl)
        m_ActiveEditPatient = NewPatient
        RaiseEvent ActivePatientAdded()
    End Sub
    Public Sub Patient_Entlassen()
        If m_ActiveEditPatient IsNot Nothing Then
            Dim Clone As Patient = m_ActiveEditPatient.CreateClone
            Clone.Entlassungsdatum = Date.Today
            Dim frm As New frm_Stammdaten_Bearbeiten(Clone)
            frm.Text = "Patienten entlassen"
            If frm.ShowDialog = DialogResult.OK Then
                m_ActiveEditPatient.ReadValues(Clone)
                m_ActiveEditPatient.RaiseChanged()
            End If
        End If
    End Sub
    Public Sub Stammdaten_Bearbeiten()
        If m_ActiveEditPatient IsNot Nothing Then
            Dim Clone As Patient = m_ActiveEditPatient.CreateClone
            Dim frm As New frm_Stammdaten_Bearbeiten(Clone)
            frm.Text = "Stammdaten bearbeiten"
            If frm.ShowDialog = DialogResult.OK Then
                m_ActiveEditPatient.ReadValues(Clone)
                m_ActiveEditPatient.RaiseChanged()
            End If
        End If
    End Sub


    Public Sub DeleteActivePatient()
        If m_ActiveEditPatient IsNot Nothing Then
            Dim Pfad As String = m_BasePath & "\" & m_ActiveEditPatient.Label.ID & ".xml"
            If IO.File.Exists(Pfad) Then
                IO.File.Delete(Pfad)
            End If
            Me.Remove(m_ActiveEditPatient.Label)
            m_ActiveEditPatient = Nothing
            m_Geaendert = True
            Speichern()
            RaiseEvent ActivePatientGeaendert()
        End If
    End Sub
    Public Sub Speichern()
        If m_Geaendert Then

            Dim Pfad As String = m_BasePath & "\" & "Patienten.xml"

            Dim Writer As XmlTextWriter = DataProvider.GetWriter(Pfad)

            For Each Lbl As PatientLabel In Me
                If Not Lbl.KurzText = "" Then
                    Writer.WriteStartElement("Label")
                    Lbl.Write_XML(Writer)
                    Writer.WriteEndElement()
                End If
            Next

            DataProvider.CloseWriter(Writer)
            m_Geaendert = False
        End If

    End Sub
    Public Sub SaveAll()
        Speichern()
        If m_ActiveEditPatient IsNot Nothing Then
            ActiveEditPatient_Speichern()
        End If
    End Sub
    Public Function TempAktuellePatienten() As List(Of Patient)
        Dim Result As New List(Of Patient)
        Dim MinDatum As New Date(1860, 1, 1)
        For Each Lbl As PatientLabel In Me
            If Lbl.Entlassungsdatum < MinDatum Then
                Result.Add(GetTempPatient(Lbl))
            End If
        Next
        Return Result
    End Function
    Public Sub ExportPatient()
        If m_ActiveEditPatient Is Nothing Then Exit Sub


        Dim dlg As New SaveFileDialog()

        dlg.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop)
        dlg.Filter = "Verschlsselte Dateien (*.encX)|*.encX"
        dlg.FilterIndex = 1
        dlg.RestoreDirectory = True
        dlg.OverwritePrompt = True

        If dlg.ShowDialog = DialogResult.OK Then
            Dim frm As New frm_PasswortAngabe
            If frm.ShowDialog <> DialogResult.OK Then
                Exit Sub
            End If

            Dim TmpPath As String = Application.StartupPath & "\TmpDecrypted.xml"
            If IO.File.Exists(TmpPath) Then
                IO.File.Delete(TmpPath)
            End If

            Dim Paket As New PatientPaket(m_ActiveEditPatient.Label, m_ActiveEditPatient.XMLPart)
            Dim Writer As XmlTextWriter = DataProvider.GetWriter(TmpPath)
            Paket.Write_XML(Writer)
            DataProvider.CloseWriter(Writer)

            Dim ListeTxt As New List(Of String)

            Using sr As New IO.StreamReader(TmpPath)
                Dim input As String
                input = sr.ReadLine
                While input IsNot Nothing
                    ListeTxt.Add(input)
                    input = sr.ReadLine
                End While
                sr.Close()
            End Using

            Dim Krypter As New EinfachCrypter(frm.TextBox1.Text)
            Dim ListeEncrypted As New List(Of String)
            For Each txt As String In ListeTxt
                ListeEncrypted.Add(Krypter.EncryptData(txt))
            Next

            Using sw As New IO.StreamWriter(dlg.FileName)
                For Each txt As String In ListeEncrypted
                    sw.WriteLine(txt)
                Next
                sw.Close()
            End Using


            If IO.File.Exists(TmpPath) Then
                IO.File.Delete(TmpPath)
            End If
        End If


    End Sub
    Public Sub ImportPatient()

        Dim myStream As IO.Stream
        Dim dlg As New OpenFileDialog()

        dlg.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Desktop)
        dlg.Filter = "Verschlsselte Dateien (*.encX)|*.encX"
        dlg.FilterIndex = 1
        dlg.RestoreDirectory = True

        If dlg.ShowDialog = DialogResult.OK Then
            myStream = dlg.OpenFile
            If myStream IsNot Nothing Then
                Dim ListeTxt As New List(Of String)

                Using sr As New IO.StreamReader(myStream)
                    Dim input As String
                    input = sr.ReadLine
                    While input IsNot Nothing
                        ListeTxt.Add(input)
                        input = sr.ReadLine
                    End While
                    sr.Close()
                End Using
                myStream.Close()

                If ListeTxt.Count > 0 Then
                    Dim frm As New frm_PasswortAngabe
                    If frm.ShowDialog <> DialogResult.OK Then
                        Exit Sub
                    End If
                    Dim Krypter As New EinfachCrypter(frm.TextBox1.Text)
                    Dim ListeResult As New List(Of String)

                    For Each txt As String In ListeTxt
                        ListeResult.Add(Krypter.DecryptData(txt))
                    Next

                    Dim TmpPath As String = Application.StartupPath & "\TmpDecrypted.xml"
                    If IO.File.Exists(TmpPath) Then
                        IO.File.Delete(TmpPath)
                    End If

                    Using sw As New IO.StreamWriter(TmpPath)
                        For Each txt As String In ListeResult
                            sw.WriteLine(txt)
                        Next
                        sw.Close()
                    End Using

                    Dim Nd As XmlNode = DataProvider.GetXML(TmpPath)
                    Dim Paket As New PatientPaket(Nd)
                    If Not Paket.IsInitialized Then
                        MessageBox.Show("Daten-Paket konnte nicht gelesen werden.", "Visite", MessageBoxButtons.OK, MessageBoxIcon.Information)
                        Exit Sub
                    Else
                        If IO.File.Exists(m_BasePath & "\" & Paket.Label.ID & ".xml") Then
                            If MessageBox.Show("Dieser Patient existiert schon einmal." & vbCrLf & "Als neuen Patienten einfgen?", "Visite", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.Yes Then
                                AddAndSetActive(Paket, True)
                            End If
                        Else
                            AddAndSetActive(Paket, False)
                        End If
                    End If

                    If IO.File.Exists(TmpPath) Then
                        IO.File.Delete(TmpPath)
                    End If
                End If


            End If
        End If
    End Sub
    Private Sub AddAndSetActive(ByVal Paket As PatientPaket, ByVal CreateNewID As Boolean)
        If CreateNewID Then Paket.Label.ID = Guid.NewGuid.ToString
        Dim UID As String = Paket.Label.ID

        Dim Writer As XmlTextWriter = DataProvider.GetWriter(m_BasePath & "\" & UID & ".xml")
        Paket.XMLPart.Write_XML(Writer)
        DataProvider.CloseWriter(Writer)

        Me.Add(Paket.Label)
        Me.SetActive(Paket.Label)
        MessageBox.Show("Import abgeschlossen.", "Visite", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub
End Class
