Imports System.Xml
Public Class DiagnoseStichwortListe
    Inherits List(Of DiagnoseStichwort)
    Public Event Changed()

    Private m_AutoCompleteCollection As New AutoCompleteStringCollection
    ReadOnly Property AutoCompleteCollection() As AutoCompleteStringCollection
        Get
            Return m_AutoCompleteCollection
        End Get
    End Property
    Private Sub ReCreateCommonLists()
        m_AutoCompleteCollection = New AutoCompleteStringCollection
        For Each Wd As DiagnoseStichwort In Me
            m_AutoCompleteCollection.Add(Wd.Wort)
        Next
    End Sub
    Public Sub Edit()
        Dim frm As New frm_DiagnoseStichwortEditor(Me)
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.Clear()
            Dim source As EinfachTextEintragsListe = frm.Source

            For Each Stw As EinfachTextEintrag In source
                If Not Stw.IsEmpty Then
                    Me.Add(New DiagnoseStichwort(Stw.Text))
                End If
            Next
            ReCreateCommonLists()
            RaiseEvent Changed()
        End If
    End Sub
    'Public Sub Edit(ByVal NewWord As String)
    '    Dim frm As New frm_BefundStichwortEditor(Me)
    '    Dim Wort As New BefundStichwort
    '    Wort.Wort = NewWord
    '    frm.ListBoxStichworte.Items.Add(Wort)
    '    frm.ListBoxStichworte.SelectedItem = Wort
    '    If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
    '        Me.Clear()
    '        For Each Stw As BefundStichwort In frm.ListBoxStichworte.Items
    '            Me.Add(Stw)
    '        Next
    '        ReCreateCommonLists()
    '        RaiseEvent Changed()
    '    End If
    'End Sub
    Public Sub New(ByVal xKn As XmlNode)
        For Each Nd As XmlNode In xKn.ChildNodes
            If Nd.Name = "DiagnoseStichwort" Then
                Me.Add(New DiagnoseStichwort(Nd))
            End If
        Next
        ReCreateCommonLists()
    End Sub
    Public Sub New()
        Me.Add(New DiagnoseStichwort("Arterielle Hypertonie"))
        Me.Add(New DiagnoseStichwort("Diabetes mellitus Typ IIb"))

        Me.Add(New DiagnoseStichwort("Koronare Herzkrankheit"))
        Me.Add(New DiagnoseStichwort("Niereninsuffizienz im Stadium der kompensierten Retention"))
        ReCreateCommonLists()
    End Sub
    Public Sub Write_XML(ByVal Writer As XmlTextWriter)
        For Each StW As DiagnoseStichwort In Me
            Writer.WriteStartElement("DiagnoseStichwort")
            StW.WriteXML(Writer)
            Writer.WriteEndElement()
        Next
    End Sub
    'Public Function GetWords() As System.Collections.Generic.List(Of String) Implements IWortListe.GetWords
    '    Dim Result As New List(Of String)
    '    For Each Wd As BefundStichwort In Me
    '        Result.Add(Wd.KurzWort)
    '    Next
    '    Return Result
    'End Function
End Class
