Public Class AusstehendSammlung
    Private m_AusstehendePflichtBefunde As New List(Of String)
    Private m_LeerBefunde As New List(Of String)

    Private WithEvents m_Befunde As BefundTextEintragsListe
    Private WithEvents m_UStichworte As BefundStichwortListe

    Public Event Changed()

    ReadOnly Property AusstehendePflichtBefunde() As List(Of String)
        Get
            Return m_AusstehendePflichtBefunde
        End Get
    End Property
    ReadOnly Property LeerBefunde() As List(Of String)
        Get
            Return m_LeerBefunde
        End Get
    End Property
    Public Sub New(ByVal Pat As Patient, ByVal UStichworte As BefundStichwortListe)
        m_Befunde = Pat.Befunde
        m_UStichworte = UStichworte

        Refresh()

    End Sub
    Private Sub Refresh()

        m_AusstehendePflichtBefunde.Clear()
        m_LeerBefunde.Clear()

        Dim PflichtBefunde As New List(Of String)
        Dim LowerPflichtBefunde As New List(Of String)

        For Each Stw As BefundStichwort In m_UStichworte
            If Stw.IstPflichtUntersuchung Then
                PflichtBefunde.Add(Stw.KurzWort.Trim)
                LowerPflichtBefunde.Add(Stw.KurzWort.Trim.ToLower)
            End If
        Next

        Dim Found As Boolean
        Dim LowerText As String
        For Each Txt As String In PflichtBefunde
            LowerText = Txt.ToLower.Trim
            Found = False
            For Each Rw As BefundTextEintrag In m_Befunde
                If Rw.Kategorie.Trim.ToLower = LowerText AndAlso Rw.Text.Trim <> "" Then
                    Found = True
                    Exit For
                End If
            Next
            If Not Found Then
                m_AusstehendePflichtBefunde.Add(Txt)
            End If
        Next

        Dim MinDatum As New Date(1860, 1, 1)

        For Each Rw As BefundTextEintrag In m_Befunde
            If Rw.Text.Trim = "" Then
                If Not LowerPflichtBefunde.Contains(Rw.Kategorie.Trim.ToLower) Then
                    Dim DatStr As String
                    If Rw.Datum < MinDatum Then
                        DatStr = ""
                    Else
                        DatStr = " " & Format(Rw.Datum, "d.M.")
                    End If

                    Dim KT As String = DatStr
                    If KT = "" Then
                        m_LeerBefunde.Add(Rw.Kategorie.Trim)
                    Else
                        m_LeerBefunde.Add(KT & " " & Rw.Kategorie.Trim)
                    End If
                End If
            End If
        Next

        RaiseEvent Changed()
    End Sub

End Class
