Public Class GesternHeuteMorgenSammlung

    Private m_Gestern As New List(Of String)
    Private m_Heute As New List(Of String)
    Private m_Morgen As New List(Of String)

    Private WithEvents m_Patient As Patient
    Private WithEvents m_Befunde As BefundTextEintragsListe
    Private WithEvents m_UStichworte As BefundStichwortListe

    Public Event Changed()
    ReadOnly Property Gestern() As List(Of String)
        Get
            Return m_Gestern
        End Get
    End Property
    ReadOnly Property Heute() As List(Of String)
        Get
            Return m_Heute
        End Get
    End Property
    ReadOnly Property Morgen() As List(Of String)
        Get
            Return m_Morgen
        End Get
    End Property

    Public Sub New(ByVal Pat As Patient, ByVal UStichworte As BefundStichwortListe)
        m_Patient = Pat
        m_Befunde = Pat.Befunde
        m_UStichworte = UStichworte

        Refresh()
    End Sub

    Private Sub Refresh()
        Dim Heute As Date = Date.Today
        Dim Gestern As Date = Date.Today.AddDays(-1)
        Dim Morgen As Date = Date.Today.AddDays(1)

        m_Heute.Clear()
        m_Gestern.Clear()
        m_Morgen.Clear()

        Dim Worte As New List(Of String)
        Dim SmallWorte As New List(Of String)

        For Each Wd As BefundStichwort In m_UStichworte
            If Wd.GHMAnzeige AndAlso Wd.KurzWort.Trim <> "" Then
                Worte.Add(Wd.KurzWort.Trim)
                SmallWorte.Add(Wd.KurzWort.Trim.ToLower)
            End If
        Next


        For Each Rw As BefundTextEintrag In m_Patient.Befunde
            Try
                If Rw.Kategorie <> "" AndAlso SmallWorte.Contains(Rw.Kategorie.ToLower.Trim) Then

                    Dim Datum As Date = Rw.Datum
                    If Datum.Date = Heute.Date Then
                        m_Heute.Add(Rw.Kategorie)
                    ElseIf Datum.Date = Gestern.Date Then
                        m_Gestern.Add(Rw.Kategorie)
                    ElseIf Datum.Date = Morgen.Date Then
                        m_Morgen.Add(Rw.Kategorie)
                    End If
                End If
            Catch ex As Exception

            End Try
        Next
        Try
            Dim EntlDatum As Date = CDate(m_Patient.Vorgeseheneentlassung)
            If EntlDatum.Date = Heute.Date Then
                m_Heute.Add("Entlassung")
            ElseIf EntlDatum.Date = Gestern.Date Then
                m_Gestern.Add("Entlassung")
            ElseIf EntlDatum.Date = Morgen.Date Then
                m_Morgen.Add("Entlassung")
            End If
        Catch ex As Exception

        End Try

        RaiseEvent Changed()
    End Sub

End Class
