Imports System.Drawing.Drawing2D
Public Class PatientenZimmerArea
    Inherits PrintArea
    Private m_PatientAreas As New List(Of PatientArea)
    Private m_ZimmerNr As String
    Private m_Font As Font

    Private m_Height As Single = 0.0F
    Private m_PatientAreaHeights As List(Of Single)
    Private m_BluePen As New Pen(Color.LightBlue)

    ReadOnly Property ZimmerNr() As String
        Get
            Return m_ZimmerNr
        End Get
    End Property
    ReadOnly Property PatientAreas() As List(Of PatientArea)
        Get
            Return m_PatientAreas
        End Get
    End Property

    Public Sub New(ByVal ZimmerNr As String)
        m_ZimmerNr = ZimmerNr
        m_Font = New Font("Arial", 12, FontStyle.Bold)
    End Sub
    Public Overrides Function GetNeededHeight(ByVal g As System.Drawing.Graphics, ByVal Width As Single) As Single

        'If m_PatientAreaHeights Is Nothing Then
        Dim FullHeight As Single = 0.0F
        m_PatientAreaHeights = New List(Of Single)
        For Each PatArea As PatientArea In m_PatientAreas
            Dim Height As Single = PatArea.GetNeededHeight(g, Width)
            FullHeight += Height
            m_PatientAreaHeights.Add(Height)
        Next
        m_Height = FullHeight + m_Font.GetHeight(g)
        'End If

        Return m_Height
    End Function

    Public Overrides Sub Print(ByVal g As System.Drawing.Graphics, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single)

        Dim RoundPath As GraphicsPath = GetRoundPath(New Rectangle(Left, Top + 5.0F, Width, m_Height - 5.0F), 10.0F)
        g.DrawPath(m_BluePen, RoundPath)

        g.DrawString(m_ZimmerNr, m_Font, New SolidBrush(ColorLib.ZimmerColor), Left, Top + 5.0F)

        Dim TmpTop As Single = m_Font.GetHeight(g) + Top

        For I As Integer = 0 To m_PatientAreaHeights.Count - 1
            'If I > 0 Then
            '    g.DrawLine(m_BluePen, Left + 25.0F, TmpTop, Left + Width - 25.0F, TmpTop)
            'End If
            m_PatientAreas(I).Print(g, Left, TmpTop, Width)
            TmpTop += m_PatientAreaHeights(I)
        Next

    End Sub
    Friend Function GetRoundPath(ByVal rect As RectangleF, ByVal radius As Single) As GraphicsPath
        Dim gp As New GraphicsPath
        Dim x, y, width, height As Single
        x = rect.X
        y = rect.Y
        width = rect.Width
        height = rect.Height

        gp.AddLine(x + radius, y, x + width - radius, y)
        gp.AddArc(x + width - (radius * 2), y, radius * 2, radius * 2, 270, 90)
        gp.AddLine(x + width, y + radius, x + width, y + height - radius)
        gp.AddArc(x + width - (radius * 2), y + height - (radius * 2), radius * 2, radius * 2, 0, 90)
        gp.AddLine(x + width - radius, y + height, x + radius, y + height)
        gp.AddArc(x, y + height - (radius * 2), radius * 2, radius * 2, 90, 90)
        gp.AddLine(x, y + height - radius, x, y + radius)
        gp.AddArc(x, y, radius * 2, radius * 2, 180, 90)
        gp.CloseFigure()
        Return gp
    End Function
End Class
