Public Class GenerellAufgabenArea
    Inherits PrintArea
    Private m_Font As Font
    Private m_StringGroups As New List(Of ColorStringGroup)

    Private m_Heights As List(Of Single)
    Private m_FullHeight As Single = 0.0F

    Private m_PatientenNamen As New List(Of ColorStringGroup)
    Private m_UnerledigteAufgaben As New List(Of ColorStringGroup)
    Private m_PatHeights As List(Of Single)
    Private m_NamenMaxWidth As Single = 0.0F

    Public Sub New()
        m_Font = New Font("Arial", 8)

        Dim Alternator As New ColorAlternator(ColorLib.NormalColor, ColorLib.WarningColor)

        For Each Rw As TextEintrag In DataProvider.Aufgaben
            If Not Rw.IsEmpty Then
                Dim Gr As New ColorStringGroup(m_Font)
                Dim Txt As String = Chr(183) & " " & Rw.Text
                If Rw.Wichtig Then
                    Gr.Add(Txt, Alternator.WarningColor)
                Else
                    Gr.Add(Txt, Alternator.NormalColor)
                End If
                m_StringGroups.Add(Gr)
                Alternator.Alternate()
            End If
        Next

        Dim StartColor As Color = Alternator.NormalColor

        Dim PatientenMitUnerledigtenAufgaben As New List(Of PatientLabel)

        For Each Lbl As PatientLabel In DataProvider.PatientProvider
            Dim TmpPat As Patient = DataProvider.PatientProvider.GetTempPatient(Lbl)
            For Each Rw As TextEintrag In TmpPat.Aufgaben
                If Not Rw.IsEmpty Then
                    PatientenMitUnerledigtenAufgaben.Add(Lbl)
                    Dim Grp As New ColorStringGroup(m_Font)
                    Grp.Add(Lbl.KurzText & ":", Alternator.NormalColor)
                    m_PatientenNamen.Add(Grp)
                    Alternator.Alternate()
                    Exit For
                End If
            Next
        Next



        'Reset To Start Color
        If Alternator.NormalColor <> StartColor Then
            Alternator.Alternate()
        End If


        Dim UnerledigteAufgaben As New List(Of TextEintrag)
        For Each Pat As PatientLabel In PatientenMitUnerledigtenAufgaben
            UnerledigteAufgaben.Clear()
            Dim TmpPat As Patient = DataProvider.PatientProvider.GetTempPatient(Pat)
            For Each Aufg As TextEintrag In TmpPat.Aufgaben
                If Not Aufg.IsEmpty Then
                    UnerledigteAufgaben.Add(Aufg)
                End If
            Next

            Dim Gr As New ColorStringGroup(m_Font)
            For Each Aufg As TextEintrag In UnerledigteAufgaben
                Dim Txt As String = Chr(183) & " " & Aufg.Text
                If Aufg.Wichtig Then
                    Gr.Add(Txt, Alternator.WarningColor)
                Else
                    Gr.Add(Txt, Alternator.NormalColor)
                End If
            Next
            m_UnerledigteAufgaben.Add(Gr)
            Alternator.Alternate()
        Next

    End Sub

    Public Overrides Function GetNeededHeight(ByVal g As System.Drawing.Graphics, ByVal Width As Single) As Single
        If m_Heights Is Nothing Then
            m_FullHeight = m_Font.GetHeight(g)
            m_Heights = New List(Of Single)
            For Each grp As ColorStringGroup In m_StringGroups
                Dim Height As Single = grp.GetHeight(g, Width - 25.0F)
                m_Heights.Add(Height)
                m_FullHeight += Height
            Next
            '   Private m_PatientenNamen As New List(Of ColorStringGroup)
            Dim Maximum As Single = 10000.0F
            For Each grp As ColorStringGroup In m_PatientenNamen
                m_NamenMaxWidth = Math.Max(grp.GetMaxWidth(g, Maximum), m_NamenMaxWidth)
            Next
            Dim DiagnosenWidth As Single = Width - 25.0F - m_NamenMaxWidth
            m_PatHeights = New List(Of Single)
            For Each grp As ColorStringGroup In m_UnerledigteAufgaben
                Dim Height As Single = grp.GetHeight(g, DiagnosenWidth)
                m_PatHeights.Add(Height)
                m_FullHeight += Height
            Next

        End If

        Return m_FullHeight
    End Function

    Public Overrides Sub Print(ByVal g As System.Drawing.Graphics, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single)
        If m_StringGroups.Count = 0 Then Exit Sub

        g.DrawString("Aufgaben", m_Font, New SolidBrush(ColorLib.ZimmerColor), Left, Top)
        Dim TmpTop As Single = Top + m_Font.GetHeight(g)
        For I As Integer = 0 To m_StringGroups.Count - 1
            m_StringGroups(I).Print(g, Left + 25.0F, TmpTop, Width - 25.0F)
            TmpTop += m_Heights(I)
        Next
        Dim DiagnosenWidth As Single = Width - 25.0F - m_NamenMaxWidth
        Dim DiagnosenLeft As Single = Left + 25.0F + m_NamenMaxWidth
        For I As Integer = 0 To m_UnerledigteAufgaben.Count - 1
            m_PatientenNamen(I).Print(g, Left + 25.0F, TmpTop, Width)
            m_UnerledigteAufgaben(I).Print(g, DiagnosenLeft, TmpTop, DiagnosenWidth)
            TmpTop += m_PatHeights(I)
        Next



    End Sub
End Class
