Public Class WordLine
    Private m_Words As New List(Of ColorStringWord)
    Private m_Text As String = ""
    ReadOnly Property Text() As String
        Get
            Return m_Text
        End Get
    End Property
    Public Sub AddWord(ByVal Word As ColorStringWord)
        m_Words.Add(Word)
        If m_Text = "" Then
            m_Text = Word.Text
        Else
            m_Text &= " " & Word.Text
        End If
    End Sub

    Public Sub JoinWordsSetWordPlace(ByVal g As Graphics, ByVal BaseFont As Font, ByVal MaxSize As SizeF)

        'If m_Words.Count > 1 Then
        Dim MeasureFormat As New StringFormat '(StringFormat.GenericDefault)

        For I As Integer = m_Words.Count - 2 To 0 Step -1
            If m_Words(I + 1).CString Is m_Words(I).CString Then
                m_Words(I).Text &= " " & m_Words(I + 1).Text
                m_Words.RemoveAt(I + 1)
            End If
        Next
        If m_Words.Count > 1 Then
            For I As Integer = 0 To m_Words.Count - 2
                m_Words(I).Text &= " "
            Next
            For I As Integer = 1 To m_Words.Count - 1
                m_Words(I).PositionInLine = m_Words(I - 1).PositionInLine + m_Words(I - 1).Text.Length
            Next
        End If



        Dim Ranges(m_Words.Count - 1) As System.Drawing.CharacterRange
        For I As Integer = 0 To m_Words.Count - 1
            Ranges(I) = New System.Drawing.CharacterRange(m_Words(I).PositionInLine, m_Words(I).Text.Length)
        Next
        MeasureFormat.SetMeasurableCharacterRanges(Ranges)

        Dim charRegions(m_Words.Count - 1) As System.Drawing.Region
        charRegions = g.MeasureCharacterRanges(m_Text, BaseFont, New RectangleF(New PointF(0.0F, 0.0F), MaxSize), MeasureFormat)

        If m_Text <> "" Then
            For I As Integer = 0 To m_Words.Count - 1
                m_Words(I).WordWidth = charRegions(I).GetBounds(g).Width
            Next
        End If


        If m_Words.Count > 1 Then
            Dim TmpLeft As Single = m_Words(0).WordWidth
            For I As Integer = 1 To m_Words.Count - 1
                m_Words(I).LeftInLine = TmpLeft
                TmpLeft += m_Words(I).WordWidth
            Next
        End If


    End Sub

    Public Function GetWidth() As Single
        Dim Result As Single = 0.0F
        For Each Wd As ColorStringWord In m_Words
            Result += Wd.WordWidth
        Next
        Return Result
    End Function

    Public Sub Print(ByVal g As System.Drawing.Graphics, ByVal BaseFont As Font, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single)

        Dim FS As FontStyle
        For Each word As ColorStringWord In m_Words
            If word.CString.Underline Then
                FS = FontStyle.Underline
            Else
                FS = FontStyle.Regular
            End If
            If word.CString.Bold Then
                FS = FS Or FontStyle.Bold
            End If
            Dim Ft As New Font(BaseFont, FS)
            'Dim Rect As New RectangleF(Left + word.LeftInLine, Top, word.WordWidth, 10.0F)
            'g.FillRectangle(New SolidBrush(Color.Gold), Rect)
            g.DrawString(word.Text, Ft, New SolidBrush(word.CString.Color), Left + word.LeftInLine, Top)
        Next
    End Sub

End Class


