Public Class VisiteDrucker
    Private WithEvents PrintPreviewDialog1 As System.Windows.Forms.PrintPreviewDialog
    Private WithEvents PD As System.Drawing.Printing.PrintDocument
    Private WithEvents PageSetupDialog1 As System.Windows.Forms.PageSetupDialog
    Private WithEvents PrintDialog1 As System.Windows.Forms.PrintDialog

    Private Samm As VisiteDruckSammlung

    Private m_Sites As List(Of VisiteDruckSite)
    Private pageNr As Integer = -1


    Public Sub New()
        Samm = New VisiteDruckSammlung

        PD = New System.Drawing.Printing.PrintDocument
        With PD.DefaultPageSettings.Margins
            .Left = 50
            .Right = 50
            .Top = 50
            .Bottom = 50
        End With

        Me.PrintPreviewDialog1 = New System.Windows.Forms.PrintPreviewDialog
        Me.PrintPreviewDialog1.Document = PD
        Me.PageSetupDialog1 = New System.Windows.Forms.PageSetupDialog
        Me.PageSetupDialog1.Document = PD
        Me.PrintDialog1 = New System.Windows.Forms.PrintDialog
        Me.PrintDialog1.UseEXDialog = True
        Me.PrintDialog1.Document = PD

    End Sub
    Public Sub Seitenansicht_Zeigen()
        If Me.PrintPreviewDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            PD.Print()
        End If
    End Sub
    Public Sub Drucken()
        Me.PrintDialog1.AllowSomePages = True
        Me.PrintDialog1.AllowSelection = False
        If Me.PrintDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Me.PD.Print()
        End If
    End Sub
    Public Sub Einfach_Drucken()
        Me.PD.Print()
    End Sub
    Public Sub Seite_Einrichten()
        If Me.PageSetupDialog1.ShowDialog() = DialogResult.OK Then
            m_Sites = Nothing
        End If
    End Sub


    Private Sub PD_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles PD.BeginPrint
        With Me.PD.PrinterSettings
            If .PrintRange = Printing.PrintRange.SomePages Then
                pageNr = .FromPage
            Else
                pageNr = 1
            End If
        End With
    End Sub

    Private Sub PD_EndPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles PD.EndPrint
        pageNr = -1
    End Sub


    Private Sub PD_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PD.PrintPage
        If m_Sites Is Nothing Then
            CreateSites(e.Graphics, e.MarginBounds.Width, e.MarginBounds.Height)
        End If


        Dim g As Graphics = e.Graphics
        m_Sites(pageNr - 1).Print(g, e.MarginBounds.Top, e.MarginBounds.Left, e.MarginBounds.Width)

        pageNr += 1

        If pageNr > m_Sites.Count Then
            e.HasMorePages = False
        Else
            e.HasMorePages = True
        End If

    End Sub

    Private Sub CreateSites(ByVal g As Graphics, ByVal Width As Integer, ByVal Height As Integer)
        m_Sites = New List(Of VisiteDruckSite)
        Samm.SplitLangeZimmerForHeight(g, Width, Height)

        Dim ActiveSite As New VisiteDruckSite
        m_Sites.Add(ActiveSite)

        Dim ActiveAreaNumber As Integer = 0
        Dim NextHeight As Single

        Dim TmpHeight As Single = 0.0F

        While ActiveAreaNumber < Samm.Areas.Count
            NextHeight = Samm.Areas(ActiveAreaNumber).GetNeededHeight(g, Width)

            If TmpHeight + NextHeight < Height Then
                ActiveSite.AddArea(NextHeight, Samm.Areas(ActiveAreaNumber))
                TmpHeight += NextHeight
            ElseIf TmpHeight = 0.0F Then
                ActiveSite.AddArea(NextHeight, Samm.Areas(ActiveAreaNumber))
                TmpHeight += NextHeight
            Else
                ActiveSite = New VisiteDruckSite
                m_Sites.Add(ActiveSite)
                TmpHeight = 0.0F
                Continue While
            End If

            ActiveAreaNumber += 1
        End While


 
    End Sub
End Class
