Public Class frm_Main

    Private WithEvents m_Provider As PatientProvider
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.PatientSelectionControl1.Init()
        m_Provider = DataProvider.PatientProvider
        Me.PatientEditor1.Provider = m_Provider
        SetActive(m_Provider.ActiveEditPatient)
    End Sub
    Private Sub m_Provider_ActivePatientAdded() Handles m_Provider.ActivePatientAdded
        SetActive(m_Provider.ActiveEditPatient)
    End Sub
    Private Sub m_Provider_ActivePatientGeaendert() Handles m_Provider.ActivePatientGeaendert
        SetActive(m_Provider.ActiveEditPatient)
    End Sub
    Private Sub SetActive(ByVal Pat As Patient)
        If Pat Is Nothing Then
            Me.ToolStripDropDownButtonBriefe.Enabled = False
            Me.PatientExportierenToolStripMenuItem.Enabled = False
            Me.PatientImportierenToolStripMenuItem.Enabled = False
        Else
            Me.ToolStripDropDownButtonBriefe.Enabled = True
            Me.PatientExportierenToolStripMenuItem.Enabled = True
            Me.PatientImportierenToolStripMenuItem.Enabled = True
        End If
    End Sub


    Private Sub frm_Main_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        DataProvider.SaveAll()
    End Sub



    Private Sub ToolStripButtonDiagnoseVorschlaege_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        DataProvider.DiagnoseStichworte.Edit()
    End Sub


    Private Sub VisitendernToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VisitendernToolStripMenuItem.Click
        Dim NewSammlung As New VisitenSammlung(DataProvider.Visiten)
        Dim frm As New frm_VisiteBearbeiten(NewSammlung)
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            DataProvider.Visiten = NewSammlung
            Me.PatientSelectionControl1.Reset()
        End If
    End Sub

    Private Sub BefundVorschlgeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BefundVorschlgeToolStripMenuItem.Click
        DataProvider.BefundStichworte.Edit()
    End Sub

    Private Sub BriefUnterschriftToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BriefUnterschriftToolStripMenuItem.Click
        DataProvider.EditUnterschriften()
    End Sub

  
    Private Sub PatientExportierenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PatientExportierenToolStripMenuItem.Click
        DataProvider.PatientProvider.ExportPatient()
    End Sub

    Private Sub PatientImportierenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PatientImportierenToolStripMenuItem.Click
        DataProvider.PatientProvider.ImportPatient()
    End Sub

    Private Sub VisiteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VisiteToolStripMenuItem.Click
        Dim Drucker As New VisiteDrucker
        Drucker.Seitenansicht_Zeigen()
    End Sub

    Private Sub PatientenlisteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PatientenlisteToolStripMenuItem.Click
        Dim Drucker As New PatientenListeDrucker(Me.PatientSelectionControl1.AllLabels)
        Drucker.Seitenansicht_Zeigen()
    End Sub

    Private Sub AufgabenTippsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AufgabenTippsToolStripMenuItem.Click
        Dim Drucker As New AufgabenTippsDrucker
        Drucker.Seitenansicht_Zeigen()
    End Sub

    Private Sub RntgenListeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RntgenListeToolStripMenuItem.Click
        Dim Drucker As New RoentgenDrucker
        Drucker.Seitenansicht_Zeigen()
    End Sub

 
    Private Sub NeuerKurzbriefToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuerKurzbriefToolStripMenuItem.Click
        If DataProvider.PatientProvider.ActiveEditPatient Is Nothing Then Exit Sub
        Dim Creator As New BriefCreator(DataProvider.PatientProvider.ActiveEditPatient, True)
    End Sub

    Private Sub NeuerBriefToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeuerBriefToolStripMenuItem.Click
        If DataProvider.PatientProvider.ActiveEditPatient Is Nothing Then Exit Sub
        Dim Creator As New BriefCreator(DataProvider.PatientProvider.ActiveEditPatient, False)
    End Sub

    Private Sub BriefeBearbeitenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BriefeBearbeitenToolStripMenuItem.Click
        If DataProvider.PatientProvider.ActiveEditPatient Is Nothing Then Exit Sub

        Dim frm As New frm_Briefe_Ansicht(DataProvider.PatientProvider.ActiveEditPatient)
        frm.ShowDialog()
    End Sub

    Private Sub BeendenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub

    Private Sub NeueBriefeExportierenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeueBriefeExportierenToolStripMenuItem.Click
        Dim Briefe As New List(Of String)
        Dim MinDate As Date = Date.Today.AddDays(-7)

        Dim FileNames() As String = IO.Directory.GetFiles(DataProvider.BriefePath)
        For Each txt As String In FileNames
            Dim FI As New IO.FileInfo(txt)
            If FI.CreationTime > MinDate OrElse FI.LastWriteTime > MinDate Then
                Briefe.Add(txt)
            End If
        Next
        If Briefe.Count = 0 Then
            MessageBox.Show("Keine neuen Briefe vorhanden.", "Visite", MessageBoxButtons.OK, MessageBoxIcon.Information)
            Exit Sub
        End If

        Dim Dlg As New FolderBrowserDialog
        Dlg.Description = "Bitte hier den Ordner auswhlen, in den die Briefe kopiert werden sollen."
        If Dlg.ShowDialog = Windows.Forms.DialogResult.OK Then
            If Dlg.SelectedPath.StartsWith(DataProvider.BriefePath) Then
                MessageBox.Show("In dieses Verzeichnis knnen Briefe nicht exportiert werden.", "Visite", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Exit Sub
            End If

            Dim SchonVorhanden As Boolean = False
            For Each txt As String In Briefe
                Dim FileName As String = IO.Path.GetFileName(txt)
                If IO.File.Exists(Dlg.SelectedPath & "\" & FileName) Then
                    SchonVorhanden = True
                    Exit For
                End If
            Next

            Dim Result As DialogResult = Windows.Forms.DialogResult.Yes
            If SchonVorhanden Then
                Result = MessageBox.Show("In diesem Verzeichnis sind einzelne Briefe mit gleichem Dateinamen schon enthalten." & vbCrLf & "Sollen sie berschrieben werden?" & vbCrLf & vbCrLf & "Mit ""Nein"" erhalten wenn notwendig neue Briefe einen neuen Dateinamen.", "Visite", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
            End If

            Select Case Result
                Case Windows.Forms.DialogResult.Cancel
                    Exit Sub
                Case Windows.Forms.DialogResult.Yes
                    For Each txt As String In Briefe
                        Try
                            Dim FileName As String = IO.Path.GetFileName(txt)
                            IO.File.Copy(txt, Dlg.SelectedPath & "\" & FileName, True)
                        Catch ex As Exception

                        End Try
                    Next
                Case Windows.Forms.DialogResult.No
                    For Each txt As String In Briefe
                        Dim FileName As String = IO.Path.GetFileName(txt)
                        Dim NewFileName As String = DataProvider.GetFreeFilePath(Dlg.SelectedPath & "\" & FileName)
                        IO.File.Copy(txt, NewFileName, False)
                    Next
            End Select

            Try
                Process.Start(Dlg.SelectedPath)
            Catch ex As Exception

            End Try

        End If
    End Sub

End Class