Public Class frm_VisiteBearbeiten
    Private m_Visits As VisitenSammlung
    Private m_AktuelleVisite As Visit
    Private m_VisitenInitialisierung As Boolean = False
    Private m_ZimmerInitialisierung As Boolean = False
    Private m_AktuellesZimmer As Zimmer = Nothing
    Private Sub SetAktuelleVisite(ByVal Vis As Visit)
        m_AktuelleVisite = Vis
        m_Visits.AktuelleVisite = Vis
        m_VisitenInitialisierung = True
        Me.TextBoxVisitenBezeichnung.Text = m_AktuelleVisite.Bezeichnung
        m_VisitenInitialisierung = False
        If m_Visits.Visiten.IndexOf(Vis) = 0 Then
            Me.CommandPanelVisiten.MoveUpEnabled = False
        Else
            Me.CommandPanelVisiten.MoveUpEnabled = True
        End If
        If m_Visits.Visiten.IndexOf(Vis) = m_Visits.Visiten.Count - 1 Then
            Me.CommandPanelVisiten.MoveDownEnabled = False
        Else
            Me.CommandPanelVisiten.MoveDownEnabled = True
        End If
        If m_Visits.Visiten.Count > 1 Then
            Me.CommandPanelVisiten.DeleteEnabled = True
        Else
            Me.CommandPanelVisiten.DeleteEnabled = False
        End If
        Me.ListViewZimmerInVisite.Items.Clear()
        Me.ButtonMoveRight.Enabled = False
        Me.CommandPanelEnthalteneZimmer.MoveUpEnabled = False
        Me.CommandPanelEnthalteneZimmer.MoveDownEnabled = False

        For Each Zi As Zimmer In m_AktuelleVisite.ZugeordneteZimmer
            Me.ListViewZimmerInVisite.Items.Add(New ZimmerListViewItem(Zi))
        Next
        If Me.ListViewZimmerInVisite.Items.Count > 0 Then
            ListViewZimmerInVisite.Items(0).Selected = True
        End If
    End Sub
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.AcceptButton = Me.OkAbortPanel1.ButtonOK
        Me.CancelButton = Me.OkAbortPanel1.ButtonAbbrechen
    End Sub
    Public Sub New(ByVal Data As VisitenSammlung)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.AcceptButton = Me.OkAbortPanel1.ButtonOK
        Me.CancelButton = Me.OkAbortPanel1.ButtonAbbrechen

        m_Visits = Data
        For Each vis As Visit In m_Visits.Visiten
            Dim NewItem As New VisitenListViewItem(vis)
            Me.ListViewVisitenAuswahl.Items.Add(NewItem)
            If vis Is m_Visits.AktuelleVisite Then
                NewItem.Selected = True
            End If
        Next

        If m_Visits.AlleZimmer.Count > 0 Then
            m_Visits.AlleZimmer.Sort(New ZimmerComparer)
            For Each Zi As Zimmer In m_Visits.AlleZimmer
                Dim NewItem As New ZimmerListViewItem(Zi)
                Me.ListViewAlleZimmer.Items.Add(NewItem)
            Next
            Me.ListViewAlleZimmer.Items(0).Selected = True
        End If
    End Sub

    Private Sub ListViewVisitenAuswahl_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewVisitenAuswahl.Leave
        If ListViewVisitenAuswahl.SelectedItems.Count = 0 Then
            For Each LVI As VisitenListViewItem In ListViewVisitenAuswahl.Items
                If LVI.Visite Is m_Visits.AktuelleVisite Then
                    LVI.Selected = True
                    Exit For
                End If
            Next
        End If
    End Sub

    Private Sub ListViewVisitenAuswahl_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewVisitenAuswahl.Resize
        ListViewVisitenAuswahl.Columns(0).Width = ListViewVisitenAuswahl.Width - 4
    End Sub

    Private Sub ListViewZimmerInVisite_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewZimmerInVisite.Resize
        ListViewZimmerInVisite.Columns(0).Width = ListViewZimmerInVisite.Width - 4
    End Sub

    Private Sub ListViewAlleZimmer_Leave(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewAlleZimmer.Leave
        If m_AktuellesZimmer IsNot Nothing Then
            If ListViewAlleZimmer.SelectedItems.Count = 0 Then
                For Each LVI As ZimmerListViewItem In ListViewAlleZimmer.Items
                    If LVI.Zimmer Is m_AktuellesZimmer Then
                        LVI.Selected = True
                        Exit For
                    End If
                Next
            End If
        End If
    End Sub

    Private Sub ListViewAlleZimmer_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewAlleZimmer.Resize
        ListViewAlleZimmer.Columns(0).Width = ListViewAlleZimmer.Width - 4
    End Sub

    Private Sub ListViewVisitenAuswahl_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewVisitenAuswahl.SelectedIndexChanged
        If ListViewVisitenAuswahl.SelectedItems.Count > 0 Then
            Dim LVI As VisitenListViewItem = ListViewVisitenAuswahl.SelectedItems(0)
            SetAktuelleVisite(LVI.Visite)
        End If
    End Sub

    Private Sub TextBoxVisitenBezeichnung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxVisitenBezeichnung.TextChanged
        If m_VisitenInitialisierung Then Exit Sub
        If TextBoxVisitenBezeichnung.Text.Trim = "" Then Exit Sub
        m_AktuelleVisite.Bezeichnung = TextBoxVisitenBezeichnung.Text
    End Sub

    Private Sub ListViewAlleZimmer_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewAlleZimmer.SelectedIndexChanged
        If ListViewAlleZimmer.SelectedItems.Count > 0 Then
            Dim LVI As ZimmerListViewItem = ListViewAlleZimmer.SelectedItems(0)
            m_AktuellesZimmer = LVI.Zimmer

            m_ZimmerInitialisierung = True
            Me.TextBoxZimmerBezeichnung.Text = m_AktuellesZimmer.ZimmerNummer
            Me.NumericUpDownAnzahlBetten.Value = m_AktuellesZimmer.AnzahlBetten
            m_ZimmerInitialisierung = False

            Me.TextBoxZimmerBezeichnung.Enabled = True
            Me.NumericUpDownAnzahlBetten.Enabled = True

            Me.ButtonMoveLeft.Enabled = True
            If ListViewAlleZimmer.Items.Count > 1 Then
                Me.CommandPanelAlleZimmer.ButtonDelete.Enabled = True
            Else
                Me.CommandPanelAlleZimmer.ButtonDelete.Enabled = False
            End If
        Else
            Me.ButtonMoveLeft.Enabled = False
            Me.CommandPanelAlleZimmer.ButtonDelete.Enabled = False

            m_ZimmerInitialisierung = True
            Me.TextBoxZimmerBezeichnung.Text = ""
            Me.NumericUpDownAnzahlBetten.Value = 2
            m_ZimmerInitialisierung = False

            Me.TextBoxZimmerBezeichnung.Enabled = False
            Me.NumericUpDownAnzahlBetten.Enabled = False

        End If
    End Sub

    Private Sub TextBoxZimmerBezeichnung_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxZimmerBezeichnung.TextChanged
        If m_ZimmerInitialisierung Then Exit Sub
        If TextBoxZimmerBezeichnung.Text <> "" Then
            m_AktuellesZimmer.ZimmerNummer = TextBoxZimmerBezeichnung.Text
        End If
    End Sub
    Private Sub NumericUpDownAnzahlBetten_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownAnzahlBetten.ValueChanged
        If m_ZimmerInitialisierung Then Exit Sub
        If m_AktuellesZimmer IsNot Nothing Then
            m_AktuellesZimmer.AnzahlBetten = NumericUpDownAnzahlBetten.Value
        End If
    End Sub
    Private Sub CommandPanelVisiten_AddNew() Handles CommandPanelVisiten.AddNew
        Dim Vis As New Visit
        Vis.Bezeichnung = "Neue Viste"
        Dim NewLVI As New VisitenListViewItem(Vis)
        m_Visits.AktuelleVisite = Vis
        If Me.ListViewVisitenAuswahl.SelectedItems.Count > 0 Then
            Dim Idx As Integer = ListViewVisitenAuswahl.Items.IndexOf(ListViewVisitenAuswahl.SelectedItems(0))
            m_Visits.Visiten.Insert(Idx + 1, Vis)
            ListViewVisitenAuswahl.Items.Insert(Idx + 1, NewLVI)
        Else
            m_Visits.Visiten.Add(Vis)
            ListViewVisitenAuswahl.Items.Add(NewLVI)
        End If
        NewLVI.Selected = True
    End Sub

    Private Sub CommandPanelVisiten_Delete() Handles CommandPanelVisiten.Delete
        If MessageBox.Show("Visite wirklich lschen?", "Viste", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.No Then Exit Sub
        Dim SelItem As VisitenListViewItem = Me.ListViewVisitenAuswahl.SelectedItems(0)
        Dim Idx As Integer = ListViewVisitenAuswahl.Items.IndexOf(SelItem)
        m_Visits.Visiten.Remove(SelItem.Visite)
        ListViewVisitenAuswahl.Items.Remove(SelItem)
        If Idx > 0 Then
            Idx -= 1
        End If
        ListViewVisitenAuswahl.Items(Idx).Selected = True
    End Sub

    Private Sub CommandPanelVisiten_MoveDown() Handles CommandPanelVisiten.MoveDown
        Dim SelItem As VisitenListViewItem = Me.ListViewVisitenAuswahl.SelectedItems(0)
        Dim Idx As Integer = ListViewVisitenAuswahl.Items.IndexOf(SelItem)
        m_Visits.Visiten.Remove(SelItem.Visite)
        m_Visits.Visiten.Insert(Idx + 1, SelItem.Visite)
        ListViewVisitenAuswahl.Items.Remove(SelItem)
        ListViewVisitenAuswahl.Items.Insert(Idx + 1, SelItem)
        SelItem.Selected = True
    End Sub

    Private Sub CommandPanelVisiten_MoveUp() Handles CommandPanelVisiten.MoveUp
        Dim SelItem As VisitenListViewItem = Me.ListViewVisitenAuswahl.SelectedItems(0)
        Dim Idx As Integer = ListViewVisitenAuswahl.Items.IndexOf(SelItem)
        m_Visits.Visiten.Remove(SelItem.Visite)
        m_Visits.Visiten.Insert(Idx - 1, SelItem.Visite)
        ListViewVisitenAuswahl.Items.Remove(SelItem)
        ListViewVisitenAuswahl.Items.Insert(Idx - 1, SelItem)
        SelItem.Selected = True
    End Sub

    Private Sub CommandPanelAlleZimmer_AddNew() Handles CommandPanelAlleZimmer.AddNew
        Dim NewZi As New Zimmer
        Dim NewItem As ZimmerListViewItem
        If m_AktuellesZimmer IsNot Nothing Then
            Try
                Dim ZimmerNr As Integer = CInt(m_AktuellesZimmer.ZimmerNummer)
                NewZi.ZimmerNummer = (ZimmerNr + 1).ToString
            Catch ex As Exception
                NewZi.ZimmerNummer = "Neues Zimmer"
            End Try
            Dim Idx As Integer = m_Visits.AlleZimmer.IndexOf(m_AktuellesZimmer)
            m_Visits.AlleZimmer.Insert(Idx + 1, NewZi)
            NewItem = New ZimmerListViewItem(NewZi)
            Me.ListViewAlleZimmer.Items.Insert(Idx + 1, NewItem)
        Else
            NewZi.ZimmerNummer = "Neues Zimmer"
            m_Visits.AlleZimmer.Add(NewZi)
            NewItem = New ZimmerListViewItem(NewZi)
            Me.ListViewAlleZimmer.Items.Add(NewItem)
        End If
        NewItem.Selected = True
    End Sub

    Private Sub CommandPanelAlleZimmer_Delete() Handles CommandPanelAlleZimmer.Delete
        If MessageBox.Show("Zimmer wirklich lschen?", "Viste", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.No Then Exit Sub

        Dim SelItem As ZimmerListViewItem = Me.ListViewAlleZimmer.SelectedItems(0)
        Dim Idx As Integer = ListViewAlleZimmer.Items.IndexOf(SelItem)
        m_Visits.AlleZimmer.Remove(SelItem.Zimmer)
        ListViewAlleZimmer.Items.Remove(SelItem)
        For Each Vis As Visit In m_Visits.Visiten
            If Vis.ZugeordneteZimmer.Contains(SelItem.Zimmer) Then
                Vis.ZugeordneteZimmer.Remove(SelItem.Zimmer)
            End If
        Next
        For Each LVI As ZimmerListViewItem In Me.ListViewZimmerInVisite.Items
            If LVI.Zimmer Is SelItem.Zimmer Then
                ListViewZimmerInVisite.Items.Remove(LVI)
                Exit For
            End If
        Next
        If Idx > 0 Then
            Idx -= 1
        End If
        ListViewAlleZimmer.Items(Idx).Selected = True
    End Sub

    Private Sub ButtonMoveLeft_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ButtonMoveLeft.Click
        Dim LVI As ZimmerListViewItem = Me.ListViewAlleZimmer.SelectedItems(0)
        Dim Idx As Integer = Me.ListViewZimmerInVisite.Items.Count
        If Me.ListViewZimmerInVisite.SelectedItems.Count > 0 Then
            Idx = ListViewZimmerInVisite.Items.IndexOf(ListViewZimmerInVisite.SelectedItems(0)) + 1
        End If

        If Not m_AktuelleVisite.ZugeordneteZimmer.Contains(LVI.Zimmer) Then
            m_AktuelleVisite.ZugeordneteZimmer.Insert(Idx, LVI.Zimmer)
            Dim NewItem As New ZimmerListViewItem(LVI.Zimmer)
            Me.ListViewZimmerInVisite.Items.Insert(Idx, NewItem)
            NewItem.Selected = True
        End If
        Dim LVIIdx As Integer = ListViewAlleZimmer.Items.IndexOf(LVI)
        If LVIIdx < ListViewAlleZimmer.Items.Count - 1 Then
            ListViewAlleZimmer.Items(LVIIdx + 1).Selected = True
        End If

    End Sub

    Private Sub ListViewZimmerInVisite_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewZimmerInVisite.SelectedIndexChanged
        If Me.ListViewZimmerInVisite.SelectedItems.Count > 0 Then
            Me.ButtonMoveRight.Enabled = True
            Dim Idx As Integer = ListViewZimmerInVisite.Items.IndexOf(ListViewZimmerInVisite.SelectedItems(0))
            If Idx = 0 Then
                Me.CommandPanelEnthalteneZimmer.MoveUpEnabled = False
            Else
                Me.CommandPanelEnthalteneZimmer.MoveUpEnabled = True
            End If
            If Idx = ListViewZimmerInVisite.Items.Count - 1 Then
                Me.CommandPanelEnthalteneZimmer.MoveDownEnabled = False
            Else
                Me.CommandPanelEnthalteneZimmer.MoveDownEnabled = True
            End If
        Else
            Me.ButtonMoveRight.Enabled = False
            Me.CommandPanelEnthalteneZimmer.MoveUpEnabled = False
            Me.CommandPanelEnthalteneZimmer.MoveDownEnabled = False
        End If

    End Sub

    Private Sub ButtonMoveRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMoveRight.Click
        Dim LVI As ZimmerListViewItem = Me.ListViewZimmerInVisite.SelectedItems(0)
        Dim Idx As Integer = ListViewZimmerInVisite.Items.IndexOf(LVI)

        m_AktuelleVisite.ZugeordneteZimmer.Remove(LVI.Zimmer)
        Me.ListViewZimmerInVisite.Items.Remove(LVI)
        If Idx > 0 Then
            Idx -= 1
        End If
        If m_AktuelleVisite.ZugeordneteZimmer.Count > 0 Then
            ListViewZimmerInVisite.Items(Idx).Selected = True
        End If
    End Sub


    Private Sub CommandPanelEnthalteneZimmer_MoveDown() Handles CommandPanelEnthalteneZimmer.MoveDown
        Dim LVI As ZimmerListViewItem = ListViewZimmerInVisite.SelectedItems(0)
        Dim Idx As Integer = m_AktuelleVisite.ZugeordneteZimmer.IndexOf(LVI.Zimmer)
        m_AktuelleVisite.ZugeordneteZimmer.Remove(LVI.Zimmer)
        m_AktuelleVisite.ZugeordneteZimmer.Insert(Idx + 1, LVI.Zimmer)
        ListViewZimmerInVisite.Items.Remove(LVI)
        ListViewZimmerInVisite.Items.Insert(Idx + 1, LVI)
        LVI.Selected = True
    End Sub

    Private Sub CommandPanelEnthalteneZimmer_MoveUp() Handles CommandPanelEnthalteneZimmer.MoveUp
        Dim LVI As ZimmerListViewItem = ListViewZimmerInVisite.SelectedItems(0)
        Dim Idx As Integer = m_AktuelleVisite.ZugeordneteZimmer.IndexOf(LVI.Zimmer)
        m_AktuelleVisite.ZugeordneteZimmer.Remove(LVI.Zimmer)
        m_AktuelleVisite.ZugeordneteZimmer.Insert(Idx - 1, LVI.Zimmer)
        ListViewZimmerInVisite.Items.Remove(LVI)
        ListViewZimmerInVisite.Items.Insert(Idx - 1, LVI)
        LVI.Selected = True
    End Sub



End Class